-------------------------------------------------------------------------------
-- Soul Sucker By Lockslap (US, Bleeding Hollow)
-- http://lockslap.com, http://wowhead-tooltips.com
-- By request of Dotzie <3
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-- Variables
-------------------------------------------------------------------------------
-- libraries
local SoulSucker		= LibStub("AceAddon-3.0"):NewAddon("SoulSucker", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0", "LibSink-2.0")
local L					= LibStub("AceLocale-3.0"):GetLocale("SoulSucker", false)
local AceConfigDialog	= LibStub("AceConfigDialog-3.0")
local LSM				= LibStub("LibSharedMedia-3.0")
SoulSucker.version		= GetAddOnMetadata("SoulSucker", "Version")

-- Curse tracking frame
local CurseTracker				= CreateFrame("Frame", "CurseTracker", UIParent)
local CurseTrackerBG			= CurseTracker:CreateTexture("CurseTrackerBG", "BACKGROUND")
local CurseTrackerElements		= CreateFrame("Frame", "CurseTrackerElements", CurseTracker, "CurseTrackerElementsTemplate")
local CurseTrackerExhaustion	= CreateFrame("Frame", "CurseTrackerExhaustion", CurseTracker, "CurseTrackerExhaustionTemplate")
local CurseTrackerTongues		= CreateFrame("Frame", "CurseTrackerTongues", CurseTracker, "CurseTrackerTonguesTemplate")
local CurseTrackerWeakness		= CreateFrame("Frame", "CurseTrackerWeakness", CurseTracker, "CurseTrackerWeaknessTemplate")

-- Lua API
local format	= string.format
local floor		= math.floor
local wipe		= table.wipe

-- string formats
local damageString		= "%s (%d)"
local chatString		= "|cff9999cc[" .. L["Soul Sucker"] .. "]|r |cffffffff%s|r"

-- settings database
local db

-- execute warnings
local drainSoulPlayed	= false
local decimationPlayed	= false
local shadowBurnPlayed	= false
local moltenCorePlayed	= false
local eradicationPlayed	= false
local nightfallPlayed	= false
local impSoulFirePlayed	= false
local backdraftPlayed	= false

-- spell constants
local RITUAL_SUMMONING		= 698
local DARK_INTENT			= 80398
local DARK_INTENT_TARGET	= 85767
local RITUAL_SOULS			= 29893
local SOULSTONE				= 20707
local DRAIN_SOUL			= 1120
local DRAIN_LIFE			= 689
local DECIMATION			= 63167
local SHADOWBURN			= 17877
local ERADICATION			= 64371
local MOLTEN_CORE			= 47383
local SHADOW_TRANCE			= 17941
local CURSE_ELEMENTS		= 1490
local CURSE_EXHAUSTION		= 18223
local CURSE_TONGUES			= 1714
local CURSE_WEAKNESS		= 702
local IMP_SOULFIRE			= 18120

-- for spell output
local inRaid			= false
local inParty			= false
local soulstoneEvent	= {}
local ritualOfSouls		= false
local ritualOfSummoning	= false
local lifeTap			= false

-- misc shizzle
local diTargets = {}

-- default options
local defaults = {
	global = {
		general = {
			enabled 		= true,
			globalFont		= false,
			fontFace 		= "Arial Narrow",
			fontOutline 	= "OUTLINE",
			fontColor		= {r = 0.6, g = 0.6, b = 0.8},
			fontSize		= 24,
		},
		warning = {
			autoDisable = false,
			drainSoul = {
				enabled			= true,
				enableText		= true,
				warningText		= L["Finish Him!"],
				warningPercent	= 25,
				enableThreshold	= false,
				minHealth		= 180000,
				playWarning		= true,
				sound			= "SS Finish Him",
				centerIcon		= false,
				centerIconAlpha	= 0.5,
				displayTime		= "2",
				centerIconID	= "1120",
				centerIconX		= "0",
				centerIconY		= "0",
				icon			= true,
				iconid			= "1120",
				fontFace		= "Arial Narrow",
				fontOutline		= "OUTLINE",
				fontColor		= {r = 0.6, g = 0.6, b = 0.8},
				fontSize		= 24,
			},
			decimation = {
				enabled			= true,
				enableText		= true,
				warningText		= L["Decimation!"],
				playWarning		= true,
				sound			= "SS Finish Him",
				centerIcon		= false,
				centerIconAlpha	= 0.5,
				displayTime		= "2",
				centerIconID	= "63158",
				centerIconX		= "0",
				centerIconY		= "0",
				icon			= true,
				iconid			= "63158",
				fontFace		= "Arial Narrow",
				fontOutline		= "OUTLINE",
				fontColor		= {r = 1, g = 0.2862745098039216, b = 0},
				fontSize		= 24,
			},
			shadowBurn = {
				enabled			= true,
				enableText		= true,
				warningText		= L["Shadowburn!"],
				warningPercent	= 20,
				enableThreshold	= false,
				minHealth		= 180000,
				playWarning		= true,
				sound			= "SS Finish Him",
				centerIcon		= false,
				centerIconAlpha	= 0.5,
				displayTime		= "2",
				centerIconID	= "17877",
				centerIconX		= "0",
				centerIconY		= "0",
				icon			= true,
				iconid			= "17877",
				fontFace		= "Arial Narrow",
				fontOutline		= "OUTLINE",
				fontColor		= {r = 0, g = 0.4235294117647059, b = 0.8},
				fontSize		= 24,
			},
		},
		ticks = {
			drainSoul = {
				enabled			= true,
				enableText		= true,
				tickText		= L["Drain Soul Ticked!"],
				tickDamage		= true,
				playTick		= true,
				sound			= "Soul Sucker Tick",
				icon			= true,
				iconid			= "1120",
				fontFace		= "Arial Narrow",
				fontOutline		= "OUTLINE",
				fontColor		= {r = 0.6, g = 0.6, b = 0.8},
				fontSize		= 24,
			},
			drainLife = {
				enabled			= true,
				enableText		= true,
				tickText		= L["Drain Life Ticked!"],
				tickDamage		= true,
				playTick		= true,
				sound			= "SS Drain Life Tick",
				icon			= true,
				iconid			= "689",
				fontFace		= "Arial Narrow",
				fontOutline		= "OUTLINE",
				fontColor		= {r = 0.0, g = 1.0, b = 0.0},
				fontSize		= 24,
			},
		},
		announce = {
			darkIntent = {
				enabled		= true,
				whisper		= true,
				tooltip		= true,
				output		= "## {SPELL} cast on >>{TARGET}<< ##",
				refreshText	= true,
				refresh		= "## {SPELL} refreshed on >>{TARGET}<< ##",
				channel		= "RAID", 
			},
			soulstone = {
				enabled 	= true,
				whisper		= true,
				whisperText	= "You were soulstoned by {CASTER}!",
				start		= true,
				startText	= "## {SPELL} on >>{TARGET}<< ##",
				fail		= true,
				failText	= "## {SPELL} on >>{TARGET}<< CANCELLED/FAILED ##",
				success		= true,
				successText	= "## {SPELL} on >>{TARGET}<< SUCCEEDED! ##",
				channel		= "RAID",
			},
			ritualOfSouls = {
				enabled	= true,
				output	= "## Casting {SPELL} ## Clicky! Clicky! ##",
				channel	= "RAID", 
			},
			ritualOfSummoning = {
				enabled	= true,
				output	= "## Casting {SPELL} ## Clicky! Clicky! ##",
				channel	= "RAID", 
			},
		},
		procs = {
			autoDisable = false,
			backdraft = {
				enabled 		= true,
				enableText		= true,
				output			= "Backdraft!",
				fadedText		= true,
				fadedOutput		= "Backdraft Faded!",
				icon			= true,
				iconid			= "47260",
				playSound		= true,
				sound			= "Soul Sucker Tick",
				fontFace		= "Arial Narrow",
				fontOutline		= "OUTLINE",
				fontColor		= {r = 0.6, g = 0.6, b = 0.8},
				fontSize		= 24,
			},
			eradication = {
				enabled 		= true,
				enableText		= true,
				output			= "Eradication!",
				icon			= true,
				iconid			= "64371",
				playSound		= true,
				sound			= "Soul Sucker Tick",
				fontFace		= "Arial Narrow",
				fontOutline		= "OUTLINE",
				fontColor		= {r = 0.6, g = 0.6, b = 0.8},
				fontSize		= 24,
			},
			impSoulFire = {
				enabled 		= true,
				enableText		= true,
				output			= "Improved Soul Fire!",
				fadedText		= true,
				fadedOutput		= "Improved Soul Fire Faded!",
				icon			= true,
				iconid			= "18120",
				playSound		= true,
				sound			= "Soul Sucker Tick",
				fontFace		= "Arial Narrow",
				fontOutline		= "OUTLINE",
				fontColor		= {r = 0.6, g = 0.6, b = 0.8},
				fontSize		= 24,
			},
			moltenCore = {
				enabled			= true,
				enableText		= true,
				output			= "Molten Core!",
				icon			= true,
				iconid			= "47383",
				playSound		= true,
				sound			= "Soul Sucker Tick",
				fontFace		= "Arial Narrow",
				fontOutline		= "OUTLINE",
				fontColor		= {r = 1.0, g = 0.49, b = 0.04},
				fontSize		= 24,
			},
			nightfall = {
				enabled			= true,
				enableText		= true,
				output			= "Nightfall!",
				icon			= true,
				iconid			= "17941",
				playSound		= true,
				sound			= "Soul Sucker Tick",
				fontFace		= "Arial Narrow",
				fontOutline		= "OUTLINE",
				fontColor		= {r = 0.6, g = 0.6, b = 0.8},
				fontSize		= 24,
			},
		},
		misc = {
			lifeTap = {
				enabled			= true,
				threshold		= 30,
				enableText		= true,
				output			= "Life Tap!",
				showValue		= true,
				manaValue		= "ACTUAL",
				icon			= true,
				iconid			= "1454",
				playSound		= true,
				sound			= "SS Life Tap",
				fontFace		= "Arial Narrow",
				fontOutline		= "OUTLINE",
				fontColor		= {r = 0.6, g = 0.6, b = 0.8},
				fontSize		= 24,
			},
			curses = {
				enabled			= true,
				locked			= false,
				scale			= 1.0,
				alpha			= 0.6,
				curseAlpha		= 1.0,
				elements		= true,
				exhaustion		= true,
				tongues			= true,
				weakness		= true,
			},
		},
		display = {
			sinkOptions		= {},
		},
	},
}

-------------------------------------------------------------------------------
-- Helper functions
-------------------------------------------------------------------------------
local function ssPrint(msg)
	local printString = "|cff33ff99[SoulSucker %s]|r |cffffffff%s|r"
	print(format(printString, SoulSucker.version, msg))
end

local function cursesShowing()
	local shown = 0
	if CurseTrackerElements:IsShown() then shown = shown + 1 end
	if CurseTrackerExhaustion:IsShown() then shown = shown + 1 end
	if CurseTrackerTongues:IsShown() then shown = shown + 1 end
	if CurseTrackerWeakness:IsShown() then shown = shown + 1 end
	return shown
end

local function isAffliction()
	local activeTalents	= GetActiveTalentGroup(false, false)
	local primTree		= GetPrimaryTalentTree(false, false, activeTalents)
	return primTree == 1 and true or false
end

local function hasTalent(talent, tree)
	local activeTalents	= GetActiveTalentGroup(false, false)
	local primTree		= GetPrimaryTalentTree(false, false, activeTalents)
	local numTalents	= GetNumTalents(primTree)
	
	if primTree ~= tree then return false end
	
	for i = 1, numTalents do
		name, _, _, _, rank, _ = GetTalentInfo(primTree, i)
		if name == talent and rank > 0 then return true end
	end
	
	return false
end

local function hasNightfall()
	-- loop through and check glyphs
	for i = 1, NUM_GLYPH_SLOTS do
		local _, glyphType, _, glyphSpell, _ = GetGlyphSocketInfo(i, activeTalents)
		if glyphSpell == 56218 then return true end
	end	
	return hasTalent("Nightfall", 1) and true or false
end

local function hasEradication()
	return hasTalent("Eradication", 1) and true or false
end

local function hasMoltenCore()
	return hasTalent("Molten Core", 2) and true or false
end

local function hasDecimation()
	return hasTalent("Decimation", 2) and true or false
end

local function hasShadowburn()
	return hasTalent("Shadowburn", 3) and true or false
end

local function hasImprovedSoulFire()
	return hasTalent("Improved Soul Fire", 3) and true or false
end

local function hasBackdraft()
	return hasTalent("Backdraft", 3) and true or false
end

local function hasBuff(name)
	for i = 1, 40 do
		local buffName = UnitAura("player", i)
		--if buffName ~= nil then print("(" .. buffName .. " == " .. name .. ") = " .. tostring(buffName == name)) end
		if buffName == name then return true end
	end
	return false
end

local function targetCurses()
	local curses = {
		elements	= false,
		exhaustion	= false,
		tongues		= false,
		weakness	= false,
	}
	for i = 1, 40 do
		local _, _, _, _, _, _, _, _, _, _, spellid = UnitAura("target", i, "HARMFUL")
		if spellid == CURSE_ELEMENTS then curses.elements = true end
		if spellid == CURSE_EXHAUSTION then curses.exhaustion = true end
		if spellid == CURSE_TONGUES then curses.tongues = true end
		if spellid == CURSE_WEAKNESS then curses.weakness = true end
	end
	return curses
end

local function isDITarget(name)
	if not name or name == "" or #diTargets == 0 then return false end
	for i = 1, #diTargets do
		if name == diTargets[i].name then return true end
	end
	return false
end

local function doSpellTick(spell, damage)
	local settings = db.ticks[spell]
	if settings.playTick and settings.sound ~= "" then
		PlaySoundFile(LSM:Fetch("sound", settings.sound))
	end
	
	-- add damage
	outputString = settings.tickDamage and format(damageString, settings.tickText, damage) or settings.tickText
	
	-- use global or individual font
	local fontFace		= db.general.globalFont and db.general.fontFace or settings.fontFace
	local fontOutline	= db.general.globalFont and db.general.fontOutline or settings.fontOutline
	local fontSize		= db.general.globalFont and db.general.fontSize or settings.fontSize
	local fontColor		= {
		r = db.general.globalFont and db.general.fontColor.r or settings.fontColor.r,
		g = db.general.globalFont and db.general.fontColor.g or settings.fontColor.g,
		b = db.general.globalFont and db.general.fontColor.b or settings.fontColor.b,
	}
	
	if settings.enableText then
		if settings.icon then
			local icon = GetSpellTexture(settings.iconid)
			SoulSucker:Pour(outputString, fontColor.r, fontColor.g, fontColor.b, fontFace, fontSize, fontOutline, nil, nil, icon)
		else
			SoulSucker:Pour(outputString, fontColor.r, fontColor.g, fontColor.b, fontFace, fontSize, fontOutline)
		end
	end
end

local function doFadedNotification(tree, spell)
	local settings = db[tree][spell]
	
	if settings.playSound and settings.sound ~= "" then
		PlaySoundFile(LSM:Fetch("sound", settings.sound))
	end
	
	-- use global or individual font
	local fontFact		= db.general.globalFont and db.general.fontFace		or settings.fontFace
	local fontOutline	= db.general.globalFont and db.general.fontOutline	or settings.fontOutline
	local fontSize		= db.general.globalFont and db.general.fontSize		or settings.fontSize
	local fontColor		= {
		r = db.general.globalFont and db.general.fontColor.r or settings.fontColor.r,
		g = db.general.globalFont and db.general.fontColor.g or settings.fontColor.g,
		b = db.general.globalFont and db.general.fontColor.b or settings.fontColor.b,
	}
	
	if settings.fadedText then
		if settings.icon then
			local icon = GetSpellTexture(settings.iconid)
			SoulSucker:Pour(settings.fadedOutput, fontColor.r, fontColor.g, fontColor.b, fontFace, fontSize, fontOutline, nil, nil, icon)
		else
			SoulSucker:Pour(settings.fadedOutput, fontColor.r, fontColor.g, fontColor.b, fontFace, fontSize, fontOutline)
		end
	end
end

local function doNotification(tree, spell)
	local settings = db[tree][spell]

	if settings.playSound and settings.sound ~= "" then
		PlaySoundFile(LSM:Fetch("sound", settings.sound))
	end	
	
	-- use global or individual font
	local fontFace		= db.general.globalFont and db.general.fontFace		or settings.fontFace
	local fontOutline	= db.general.globalFont and db.general.fontOutline	or settings.fontOutline
	local fontSize		= db.general.globalFont and db.general.fontSize		or settings.fontSize
	local fontColor		= {
		r = db.general.globalFont and db.general.fontColor.r or settings.fontColor.r,
		g = db.general.globalFont and db.general.fontColor.g or settings.fontColor.g,
		b = db.general.globalFont and db.general.fontColor.b or settings.fontColor.b,
	}
	
	if spell ~= "lifeTap" then
		outputValue = settings.output
	else
		if not settings.showValue then
			outputValue = settings.output
		else
			outputValue = (settings.manaValue == "ACTUAL") and format(settings.output .. " (%d)", UnitPower("player", SPELL_POWER_MANA)) or format(settings.output .. " (%d%%)", floor(UnitPower("player", SPELL_POWER_MANA) / UnitPowerMax("player", SPELL_POWER_MANA) * 100))
		end
	end
	
	if settings.enableText then
		if settings.icon then
			local icon = GetSpellTexture(settings.iconid)
			SoulSucker:Pour(outputValue, fontColor.r, fontColor.g, fontColor.b, fontFace, fontSize, fontOutline, nil, nil, icon)
		else
			SoulSucker:Pour(outputValue, fontColor.r, fontColor.g, fontColor.b, fontFace, fontSize, fontOutline)
		end
	end
end

local function doExecuteWarning(spell)
	local settings = db.warning[spell]

	if settings.playWarning and settings.sound ~= "" then
		PlaySoundFile(LSM:Fetch("sound", settings.sound))
	end
	
	if settings.centerIcon then
		-- center icon
		local CenterIcon	= CreateFrame("Frame", "SoulSuckerCenterIcon", WorldFrame)
		local CenterIconBG	= CenterIcon:CreateTexture("SoulSuckerCenterIconBG", "BACKGROUND")
		local background	= settings.centerIconID and GetSpellTexture(settings.centerIconID) or GetSpellTexture(DRAIN_SOUL)
		CenterIconBG:SetTexture(background)
		CenterIconBG:SetAlpha(settings.centerIconAlpha)
		CenterIconBG:SetAllPoints()
		CenterIcon:SetMovable(false)
		CenterIcon:EnableMouse(false)
		CenterIcon:SetWidth(50)
		CenterIcon:SetHeight(50)
		CenterIcon:SetPoint("CENTER", tonumber(settings.centerIconX), tonumber(settings.centerIconY))	-- center of the screen
		CenterIcon:Show()
		
		-- start the timer to hide the icon
		SoulSucker:ScheduleTimer(function() 
			UIFrameFlash(CenterIcon, 0, 1, 1, false, 0, 0)
			CenterIcon = nil
		end, tonumber(settings.displayTime))
	
	elseif settings.enableText then
		-- use global or individual font
		local fontFace = db.general.globalFont == true and db.general.fontFace or settings.fontFace
		local fontOutline = db.general.globalFont == true and db.general.fontOutline or settings.fontOutline
		local fontSize = db.general.globalFont == true and db.general.fontSize or settings.fontSize
		local fontColor = {
			r = db.general.globalFont and db.general.fontColor.r or settings.fontColor.r,
			g = db.general.globalFont and db.general.fontColor.g or settings.fontColor.g,
			b = db.general.globalFont and db.general.fontColor.b or settings.fontColor.b,
		}
	
	
		if settings.icon then
			local icon = GetSpellTexture(settings.iconid) or GetSpellTexture(DRAIN_SOUL)
			SoulSucker:Pour(settings.warningText, fontColor.r, fontColor.g, fontColor.b, fontFace, fontSize, fontOutline, nil, nil, icon)
		else
			SoulSucker:Pour(settings.warningText, fontColor.r, fontColor.g, fontColor.b, fontFace, fontSize, fontOutline)
		end
	end
	
	-- set to true, so as not to warn again for this target
	warningPlayed = true
end

-------------------------------------------------------------------------------
-- Event handling
-------------------------------------------------------------------------------
	-- they changed spec, so if auto disable is enabled then change settings around
function SoulSucker:ACTIVE_TALENT_GROUP_CHANGED()
	if db.warning.autoDisable then
		db.warning.drainSoul.enabled	= isAffliction()
		db.warning.decimation.enabled	= hasDecimation()
		db.warning.shadowBurn.enabled	= hasShadowburn() 
	end
	
	if db.procs.autoDisable then
		db.procs.eradication.enabled	= hasEradication()
		db.procs.moltenCore.enabled		= hasMoltenCore()
		db.procs.nightfall.enabled		= hasNightfall()
	end
	
	-- so you're not warned when you change specs
	if db.misc.lifeTap.enabled and not lifeTap then
		lifeTap = true
	end
end
		
-- look for drain soul and drain life ticks
function SoulSucker:COMBAT_LOG_EVENT_UNFILTERED(...)
	local type = select(3, ...)
	local source = select(6, ...)
	if type == "SPELL_PERIODIC_DAMAGE" and source == UnitName("player") then
		-- drain soul tick
		if db.ticks.drainSoul.enabled and select(12, ...) == GetSpellInfo(DRAIN_SOUL) then
			doSpellTick("drainSoul", select(14, ...))
		end
		
		-- drain life tick
		if db.ticks.drainLife.enabled and select(12, ...) == GetSpellInfo(DRAIN_LIFE) then
			doSpellTick("drainLife", select(14, ...))
		end
	end
end
		
-- look for unit health changes
function SoulSucker:UNIT_HEALTH()
	-- drain soul tiem!
	if db.warning.drainSoul.enabled and not drainSoulPlayed and UnitIsEnemy("player", "target") and not UnitIsDead("target") then
		-- make sure health is > the minimum health, if enabled
		if not db.warning.drainSoul.enableThreshold or UnitHealthMax("target") > db.warning.drainSoul.minHealth then
			-- now calculate the target's health percent and check it against our threshold
			local healthPercent = floor((UnitHealth("target") / UnitHealthMax("target")) * 100)
			if healthPercent <= db.warning.drainSoul.warningPercent then
				doExecuteWarning("drainSoul")
				drainSoulPlayed = true
			end
		end
	end
	
	-- shadowburn!
	if db.warning.shadowBurn.enabled and not shadowBurnPlayed and UnitIsEnemy("player", "target") and not UnitIsDead("target") then
		-- make sure health is > the minimum health, if enabled
		if not db.warning.drainSoul.enableThreshold or UnitHealthMax("target") > db.warning.shadowBurn.minHealth then
			-- now calculate the target's health percent and check it against our threshold
			local healthPercent = floor((UnitHealth("target") / UnitHealthMax("target")) * 100)
			if healthPercent <= db.warning.shadowBurn.warningPercent then
				doExecuteWarning("shadowBurn")
				shadowBurnPlayed = true
			end
		end
	end
end
	
function SoulSucker:UNIT_AURA()	

	-- decimation
	if db.warning.decimation.enabled then
		if not decimationPlayed and hasBuff("Decimation") then
			doExecuteWarning("decimation")
			decimationPlayed = true
		elseif decimationPlayed and not hasBuff("Decimation") then
			decimationPlayed = false
		end
	end
	
	-- backdraft
	if db.procs.backdraft.enabled then
		if hasBuff("Backdraft") then
			if not backdraftPlayed and db.procs.backdraft.enableText then
				doNotification("procs", "backdraft")
			end
			backdraftPlayed = true
		elseif not hasBuff("Backdraft") then
			if backdraftPlayed and db.procs.backdraft.fadedText then
				doFadedNotification("procs", "backdraft")
			end
			backdraftPlayed = false
		end
	end
	
	-- eradication
	if db.procs.eradication.enabled then
		if not eradicationPlayed and hasBuff("Eradication") then
			doNotification("procs", "eradication")
			eradicationPlayed = true
		elseif eradicationPlayed and not hasBuff("Eradication") then
			eradicationPlayed = false
		end
	end
	
	-- improved soul fire
	if db.procs.impSoulFire.enabled then
		if hasBuff("Improved Soul Fire") then
			if not impSoulFirePlayed and db.procs.impSoulFire.enableText then
				doNotification("procs", "impSoulFire")
			end
			impSoulFirePlayed = true
		elseif not hasBuff("Improved Soul Fire") then
			if impSoulFirePlayed and db.procs.impSoulFire.fadedText then
				doFadedNotification("procs", "impSoulFire")
			end
			impSoulFirePlayed = false
		end
	end
	
	-- molten core
	if db.procs.moltenCore.enabled then
		if not moltenCorePlayed and hasBuff("Molten Core") then
			doNotification("procs", "moltenCore")
			moltenCorePlayed = true
		elseif moltenCorePlayed and not hasBuff("Molten Core") then
			moltenCorePlayed = false
		end
	end
	
	-- nightfall
	if db.procs.nightfall.enabled then
		if not nightfallPlayed and hasBuff("Shadow Trance") then
			doNotification("procs", "nightfall")
			nightfallPlayed = true
		elseif nightfallPlayed and not hasBuff("Shadow Trance") then
			nightfallPlayed = false
		end
	end
	
end
	
-- cast ritual of souls/summoning
function SoulSucker:UNIT_SPELLCAST_CHANNEL_START(event, unit, name, _, _, id)
	--local unit, name, _, _, id = ...
	if UnitName("player") == UnitName(unit) then
		-- ritual of souls
		if db.announce.ritualOfSouls.enabled and db.announce.ritualOfSouls.channel ~= "NONE" and id == RITUAL_SOULS and not ritualOfSouls then
			local channel, message = db.announce.ritualOfSouls.channel, db.announce.ritualOfSouls.output
			local spellLink = GetSpellLink(RITUAL_SOULS)
			-- adjust channel based on raid/party status
			if db.announce.ritualOfSouls.channel == "PARTY" then
				channel = not inParty and "CHATFRAME" or "PARTY"
			elseif db.announce.ritualOfSouls.channel == "RAID" or db.announce.ritualOfSouls.channel == "RAID_WARNING" then
				channel = not inRaid and "CHATFRAME" or db.announce.ritualOfSouls.channel
			end
			local message = db.announce.ritualOfSouls.output
			-- how we output the message depends on the channel
			if channel ~= "CHATFRAME" then
				SendChatMessage(message:gsub("{SPELL}", spellLink), channel)
			else
				ssPrint(message:gsub("{SPELL}", spellLink))
			end
			ritualOfSouls = true
		elseif db.announce.ritualOfSummoning.enabled and db.announce.ritualOfSummoning.channel ~= "NONE" and id == RITUAL_SUMMONING and not ritualOfSummoning then
			local channel, message = db.announce.ritualOfSummoning.channel, db.announce.ritualOfSummoning.output
			local spellLink = GetSpellLink(RITUAL_SUMMONING)
			-- adjust channel based on raid/party status
			if db.announce.ritualOfSummoning.channel == "PARTY" then
				channel = not inParty and "CHATFRAME" or "PARTY"
			elseif db.announce.ritualOfSummoning.channel == "RAID" or db.announce.ritualOfSummoning.channel == "RAID_WARNING" then
				channel = not inRaid and "CHATFRAME" or db.announce.ritualOfSummoning.channel
			end
			local message = db.announce.ritualOfSummoning.output
			-- how we output the message depends on the channel
			if channel ~= "CHATFRAME" then
				SendChatMessage(message:gsub("{SPELL}", spellLink), channel)
			else
				ssPrint(message:gsub("{SPELL}", spellLink))
			end
			ritualOfSummoning = true
		end
	end
end
		
-- spell cast sent (soulstone)
function SoulSucker:UNIT_SPELLCAST_SENT(event, unit, spell, _, target, line)
	--local unit, spell, _, line, spellid = ...
	if db.announce.soulstone.enabled and db.announce.soulstone.start and UnitName("player") == UnitName(unit) and spell == "Soulstone Resurrection" then
		local channel, message = db.announce.soulstone.channel, db.announce.soulstone.startText
		local spellLink = GetSpellLink(SOULSTONE)
		
		if channel ~= "NONE" then
			-- adjust channel based on party/raid status
			if db.announce.soulstone.channel == "PARTY" then
				channel = not inParty and "CHATFRAME" or "PARTY"
			elseif db.announce.soulstone.channel == "RAID" or db.announce.soulstone.channel == "RAID_WARNING" then
				channel = not inRaid and "CHATFRAME" or db.announce.soulstone.channel
			end
			
			-- send the chat message
			if channel ~= "CHATFRAME" then
				SendChatMessage(message:gsub("{TARGET}", target):gsub("{SPELL}", spellLink), channel)
			else
				ssPrint(message:gsub("{TARGET}", target):gsub("{SPELL}", spellLink))
			end
		end
		
		-- for tracking the end result of this soulstone cast (succes or failed/cancelled)
		soulstoneEvent = {
			line = line,
			target = target
		}
	end
end

-- spell cast failed
function SoulSucker:UNIT_SPELLCAST_STOP(event, unit, spell, _, line, spellid)
	-- wow tracks the progress of a spell cast via the lineID (we use line) parameter
	if db.announce.soulstone.enabled and db.announce.soulstone.channel ~= "NONE" and db.announce.soulstone.fail and soulstoneEvent.line == line then
		local channel, message = db.announce.soulstone.channel, db.announce.soulstone.failText
		local spellLink = GetSpellLink(SOULSTONE)
		
		-- adjust channel based on party and raid
		if db.announce.soulstone.channel == "PARTY" then
			channel = not inParty and "CHATFRAME" or "PARTY"
		elseif db.announce.soulstone.channel == "RAID" or db.announce.soulstone.channel == "RAID_WARNING" then
			channel = not inRaid and "CHATFRAME" or db.announce.soulstone.channel
		end
		
		-- send the chat message
		if channel ~= "CHATFRAME" then
			SendChatMessage(message:gsub("{TARGET}", soulstoneEvent.target):gsub("{SPELL}", spellLink), channel)
		else
			ssPrint(message:gsub("{TARGET}", soulstoneEvent.target):gsub("{SPELL}", spellLink))
		end
		
		wipe(soulstoneEvent)
	end
end
 		
-- spell cast succeeded
function SoulSucker:UNIT_SPELLCAST_SUCCEEDED(event, unit, spell, _, line, spellid)
	-- soulstone
	if db.announce.soulstone.enabled and db.announce.soulstone.channel ~= "NONE" and db.announce.soulstone.success and spellid == SOULSTONE and soulstoneEvent.line == line then
		local channel, message = db.announce.soulstone.channel, db.announce.soulstone.successText
		local spellLink = GetSpellLink(SOULSTONE)
		
		-- adjust channel based on party and raid
		if db.announce.soulstone.channel == "PARTY" then
			channel = not inParty and "CHATFRAME" or "PARTY"
		elseif db.announce.soulstone.channel == "RAID" or db.announce.soulstone.channel == "RAID_WARNING" then
			channel = not inRaid and "CHATFRAME" or db.announce.soulstone.channel
		end
		
		-- send the chat message
		if channel ~= "CHATFRAME" then
			SendChatMessage(message:gsub("{TARGET}", soulstoneEvent.target):gsub("{SPELL}", spellLink), channel)
		else
			ssPrint(message:gsub("{TARGET}", soulstoneEvent.target):gsub("{SPELL}", spellLink))
		end
		
		-- send the whisper (if set to, and it wasnt a self soulstone)
		if db.announce.soulstone.whisper and soulstoneEvent.target ~= UnitName("player") then
			SendChatMessage(db.announce.soulstone.whisperText:gsub("{CASTER}", UnitName("player")), "WHISPER", nil, soulstoneEvent.target)
		end
		
		wipe(soulstoneEvent)		
	
	-- dark intent cast by the user
	elseif db.announce.darkIntent.enabled and spellid == DARK_INTENT and UnitName("player") == UnitName(unit) and not isDITarget(UnitName("target")) then
		local target, channel, message = UnitName("target"), db.announce.darkIntent.channel, db.announce.darkIntent.output
		local spellLink = GetSpellLink(DARK_INTENT)
		-- something happened, or they casted DI on their pet (hey, it happens ;-))
		if not target or target == UnitName("pet") then return end
		
		-- adjust channel based on party/raid status
		if channel == "PARTY" then
			channel = not inParty and "CHATFRAME" or "PARTY"
		elseif channel == "RAID" or channel == "RAID_WARNING" then
			channel = not inRaid and "CHATFRAME" or db.announce.darkIntent.channel
		end
		
		-- send the chat message
		if channel ~= "NONE" then
			if channel ~= "CHATFRAME" then
				SendChatMessage(message:gsub('{SPELL}', spellLink):gsub('{TARGET}', target), channel)
			else
				ssPrint(message:gsub('{SPELL}', spellLink):gsub('{TARGET}', target))
			end
		end
		
		-- whisper the target (if set to)
		if db.announce.darkIntent.whisper then
			SendChatMessage(format(L["You have %s from %s!"], spellLink, UnitName("player")), "WHISPER", nil, target)
		end
		
		-- update the di targets table
		if #diTargets > 0 then wipe(diTargets) end
		local class, classFile		= UnitClass("target")
		local classRGB				= RAID_CLASS_COLORS[classFile]
		local classHex				= format("%02x%02x%02x", classRGB.r * 255, classRGB.g * 255, classRGB.b * 255)
		diTargets[#diTargets + 1] = {
			name		= UnitName("target"),
			nameColored	= format("|cff%s%s|r", classHex, UnitName("target")),
			caster		= format("|cff9999cc%s|r", UnitName("player"))
		}
	elseif db.announce.darkIntent.enabled and db.announce.darkIntent.channel ~= "NONE" and db.announce.darkIntent.refreshText and spellid == DARK_INTENT and UnitName("player") == UnitName(unit) and isDITarget(UnitName("target")) then
		-- for refreshing di announcements
		local target, channel, message = UnitName("target"), db.announce.darkIntent.channel, db.announce.darkIntent.refresh
		local spellLink = GetSpellLink(DARK_INTENT)
		
		if not target or target == UnitName("pet") then return end
		
		-- adjust channel based on party/raid
		if channel == "PARTY" then
			channel = not inParty and "CHATFRAME" or "PARTY"
		elseif channel == "RAID" or channel == "RAID_WARNING" then
			channel = not inRaid and "CHATFRAME" or db.announce.darkIntent.channel
		end
		
		-- send the message
		if channel ~= "CHATFRAME" then
			SendChatMessage(message:gsub('{SPELL}', spellLink):gsub('{TARGET}', target), channel)
		else
			ssPrint(message:gsub('{SPELL}', spellLink):gsub('{TARGET}', target))
		end
	end
end
	
-- look for target changes to reset the warnings
function SoulSucker:PLAYER_TARGET_CHANGED()
	drainSoulPlayed = false
	shadowBurnPlayed = false
	
	-- for curse tracking
	if db.misc.curses.enabled and UnitExists("target") then
		if UnitCanAttack("player", "target") then
			CurseTracker:Show()
		else
			CurseTracker:Hide()
		end
	else
		CurseTracker:Hide()
	end
	
	-- if not locked, then show regardless of target
	if db.misc.curses.enabled and not db.misc.curses.locked then CurseTracker:Show() end
end

-- life tap monitor
function SoulSucker:UNIT_POWER(event, unit, powerType)
	if UnitName(unit) == UnitName("player") and db.misc.lifeTap.enabled and powerType == "MANA" and not UnitIsDead("player") then
		local manaPercentage = floor(UnitPower(unit, powerType) / UnitPowerMax(unit, powerType) * 100)	-- calculate the percentage of current mana
		if manaPercentage <= db.misc.lifeTap.threshold and not lifeTap then
			doNotification("misc", "lifeTap")
			lifeTap = true
		elseif manaPercentage > db.misc.lifeTap.threshold and lifeTap == true then
			-- mana percent is above threshold, and it has already notified, so reset it
			lifeTap = false
		end
	end
end

-- register events we track
SoulSucker:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")	-- to watch for drain soul ticks
SoulSucker:RegisterEvent("UNIT_HEALTH")					-- to check the target's health percent
SoulSucker:RegisterEvent("PLAYER_TARGET_CHANGED")		-- to reset the execute warning
SoulSucker:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")	-- changed talent spec
SoulSucker:RegisterEvent("UNIT_AURA")					-- check a unit's buff/debuffs
SoulSucker:RegisterEvent("UNIT_POWER")					-- for life tap
SoulSucker:RegisterEvent("UNIT_SPELLCAST_SENT")			-- spell cast request sent to the server
SoulSucker:RegisterEvent("UNIT_SPELLCAST_STOP")			-- spell cast stopped
SoulSucker:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")	-- spell cast succeeded
SoulSucker:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")-- channeling begun

-------------------------------------------------------------------------------
-- Dark Intent target tracking
-------------------------------------------------------------------------------
function SoulSucker:UpdateDITargets()
	if not db.announce.darkIntent.tooltip or (not inParty and not inRaid) then return end
	local maxPlayers	= not inRaid and GetNumPartyMembers() or GetNumRaidMembers()
	local partyRaid		= not inRaid and "party" or "raid"
	wipe(diTargets)
	for i = 1, maxPlayers do
		for x = 1, 40 do
			local _, _, _, _, _, _, _, caster, _, _, spellID = UnitAura(partyRaid .. tostring(i), x)
			if spellID == DARK_INTENT_TARGET then
				if not isDITarget(UnitName(partyRaid .. tostring(i))) then
					local casterName			= UnitName(caster)
					local class, classFile		= UnitClass(partyRaid .. tostring(i))
					local classRGB				= RAID_CLASS_COLORS[classFile]
					local classColor			= format("%02x%02x%02x", classRGB.r * 255, classRGB.g * 255, classRGB.b * 255)
					diTargets[#diTargets + 1] = {
						name		= UnitName(partyRaid .. tostring(i)),
						nameColored	= format("|cff%s%s|r", classColor, UnitName(partyRaid .. tostring(i))),
						caster		= format("|cff9999cc%s|r", casterName)
					}
				end
			end
		end
	end
end

-------------------------------------------------------------------------------
-- Party/Raid status
-------------------------------------------------------------------------------
function SoulSucker:UpdateRaidPartyStatus()
	inParty	= GetNumPartyMembers() > 0 and true or false
	inRaid	= GetNumRaidMembers() > 0 and true or false
	if inRaid and inParty then inParty = false end
end

function SoulSucker:UpdateRitualSpells()
	if ritualOfSouls == true then ritualOfSouls = false end
	if ritualOfSummoning == true then ritualOfSummoning = false end
end

-------------------------------------------------------------------------------
-- Curse tracking frame
-------------------------------------------------------------------------------
function CurseTracker:SetScale(scale)
	local xY, padding = scale * 32, scale * 2
	CurseTracker:SetHeight(xY)
	CurseTracker:SetWidth(cursesShowing() * (xY + padding))

	CurseTrackerElements:SetHeight(xY)
	CurseTrackerElements:SetWidth(xY)
	
	CurseTrackerExhaustion:SetHeight(xY)
	CurseTrackerExhaustion:SetWidth(xY)
	
	CurseTrackerTongues:SetHeight(xY)
	CurseTrackerTongues:SetWidth(xY)
	
	CurseTrackerWeakness:SetHeight(xY)
	CurseTrackerWeakness:SetWidth(xY)
end

function CurseTracker:SetCurseAlpha(alpha)
	CurseTrackerElements:SetAlpha(alpha)
	CurseTrackerExhaustion:SetAlpha(alpha)
	CurseTrackerTongues:SetAlpha(alpha)
	CurseTrackerWeakness:SetAlpha(alpha)
end

function CurseTracker:UpdateCurses()
	local left = 2
	
	if db.misc.curses.elements then
		CurseTrackerElements:SetPoint("LEFT", left, 0)
		CurseTrackerElements:SetAlpha(db.misc.curses.alpha)
		CurseTrackerElements:Show()
		left = left + 34
	else
		CurseTrackerElements:Hide()
	end
	
	if db.misc.curses.exhaustion then
		CurseTrackerExhaustion:SetPoint("LEFT", left, 0)
		CurseTrackerExhaustion:SetAlpha(db.misc.curses.alpha)
		CurseTrackerExhaustion:Show()
		left = left + 34
	else
		CurseTrackerExhaustion:Hide()
	end
	
	if db.misc.curses.tongues then
		CurseTrackerTongues:SetPoint("LEFT", left, 0)
		CurseTrackerTongues:SetAlpha(db.misc.curses.alpha)
		CurseTrackerTongues:Show()
		left = left + 34
	else
		CurseTrackerTongues:Hide()
	end
	
	if db.misc.curses.weakness then
		CurseTrackerWeakness:SetPoint("LEFT", left, 0)
		CurseTrackerWeakness:SetAlpha(db.misc.curses.alpha)
		CurseTrackerWeakness:Show()
	else
		CurseTrackerWeakness:Hide()
	end
	
	CurseTracker:SetWidth((cursesShowing() * CurseTrackerElements:GetWidth()) + (2 * db.misc.curses.scale))
end

-- initial setup
function CurseTracker:Setup()
	CurseTracker:EnableMouse(true)
	CurseTracker:SetResizable(false)
	CurseTracker:SetMovable(true)
	CurseTracker:SetUserPlaced(true)
	CurseTracker:SetPoint("CENTER")
	CurseTrackerBG:SetTexture(0, 0, 0, db.misc.curses.alpha)
	CurseTrackerBG:SetAllPoints()
	
	if db.misc.curses.locked then
		CurseTrackerBG:Hide()
		CurseTracker:SetScript("OnMouseDown", nil)
	else
		CurseTrackerBG:Show()
		CurseTracker:SetScript("OnMouseDown", function() CurseTracker:StartMoving() end)
	end
	
	CurseTracker:SetScale(db.misc.curses.scale)
	CurseTracker:UpdateCurses()
	
	if db.misc.curses.enabled and UnitExists("target") then
		if UnitCanAttack("player", "target") then
			CurseTracker:Show()
		else
			CurseTracker:Hide()
		end
	else
		CurseTracker:Hide()
	end
	
	-- if not locked, then show regardless of target
	if db.misc.curses.enabled and not db.misc.curses.locked then CurseTracker:Show() end
end

local interval = 0
CurseTracker:SetScript("OnUpdate", function(self, elapsed)
	interval = interval + elapsed
	
	if interval >= 0.5 and db.misc.curses.enabled then
		-- update the target's curses
		local curses = targetCurses()
		
		if db.misc.curses.elements and curses.elements then
			CurseTrackerElements:SetAlpha(db.misc.curses.curseAlpha)
		elseif db.misc.curses.elements and not curses.elements then
			CurseTrackerElements:SetAlpha(db.misc.curses.alpha)
		end
		
		if db.misc.curses.exhaustion and curses.exhaustion then
			CurseTrackerExhaustion:SetAlpha(db.misc.curses.curseAlpha)
		elseif db.misc.curses.exhaustion and not curses.exhaustion then
			CurseTrackerExhaustion:SetAlpha(db.misc.curses.alpha)
		end
		
		if db.misc.curses.tongues and curses.tongues then
			CurseTrackerTongues:SetAlpha(db.misc.curses.curseAlpha)
		elseif db.misc.curses.tongues and not curses.tongues then
			CurseTrackerTongues:SetAlpha(db.misc.curses.alpha)
		end
		
		if db.misc.curses.weakness and curses.weakness then
			CurseTrackerWeakness:SetAlpha(db.misc.curses.curseAlpha)
		elseif db.misc.curses.weakness and not curses.weakness then
			CurseTrackerWeakness:SetAlpha(db.misc.curses.alpha)
		end
		interval = 0
	elseif interval >= 0.5 then
		interval = 0
	end
end)

CurseTracker:SetScript("OnDragStop", function() CurseTracker:StopMovingOrSizing() end)
CurseTracker:SetScript("OnMouseUp", function() CurseTracker:StopMovingOrSizing() end)

-------------------------------------------------------------------------------
-- AddOn Enabled/Disabled
-------------------------------------------------------------------------------
function SoulSucker:OnEnable()
	inParty = GetNumPartyMembers() > 0 and true or false
	inRaid = GetNumRaidMembers() > 0 and true or false

	-- schedule our timer to keep DI targets updated
	self.diTimer = self:ScheduleRepeatingTimer("UpdateDITargets", 5)
	-- schedule timer to track raid/party status
	self.partyRaidTimer = self:ScheduleRepeatingTimer("UpdateRaidPartyStatus", 1)
	-- soulwell + summoning
	self.ritualTimer = self:ScheduleRepeatingTimer("UpdateRitualSpells", 15)
end

function SoulSucker:OnDisable()
	-- disable the timer
	self:CancelTimer(self.diTimer, true)
	self:CancelTimer(self.partyRaidTimer, true)
	self:CancelTimer(self.ritualTimer, true)
	GameTooltip:HookScript("OnTooltipSetSpell", function() end)
end

-- hook the tooltip
GameTooltip:HookScript("OnTooltipSetSpell", function(self)
	local name, _, id = self:GetSpell()
	local tooltipLine = ""
	if #diTargets > 0 and (id == DARK_INTENT or id == DARK_INTENT_TARGET) then
		self:AddLine(" ")
		self:AddLine("|cffffffff" .. L["Dark Intent Targets"] .. "|r")
		i = 1
		for _, entry in pairs(diTargets) do
			tooltipLine = tooltipLine .. format("%s (%s)", entry.nameColored, entry.caster)
			if i ~= #diTargets then tooltipLine = tooltipLine .. ", " end
			i = i + 1
		end
		self:AddLine(tooltipLine)
		self:Show()
	end
end)

-------------------------------------------------------------------------------
-- Configuration options
-------------------------------------------------------------------------------
local options = {
	type = "group",
	name = "Soul Sucker",
	args = {
		general = {
			type = "group",
			name = L["General Settings"],
			order = 1,
			args = {
				globalFont = {
					type = "toggle",
					order = 1,
					name = L["Use Global Font"],
					desc = L["Use a global font instead of individual ones."],
					width = "double",
					get = function() return db.general.globalFont end,
					set = function(_, value) db.general.globalFont = value end,
				},
				fontSettings = {
					type = "group",
					order = 2,
					name = L["Global Font Settings"],
					guiInline = true,
					disabled = function() return not db.general.globalFont end,
					args = {
						fontFace = {
							type = "select", dialogControl = "LSM30_Font",
							order = 1,
							name = L["Font"],
							desc = L["The global font face."],
							values = AceGUIWidgetLSMlists.font,
							get = function() return db.general.fontFace end,
							set = function(_, value) db.general.fontFace = value end,
						},
						fontOutline = {
							type = "select",
							order = 2,
							name = L["Font Outline"],
							desc = L["Outline of the font."],
							get = function() return db.general.fontOutline end,
							set = function(_, value) db.general.fontOutline = value end,
							values = {
								["NORMAL"] 			= L["Normal"],
								["OUTLINE"]			= L["Outline"],
								["THICKOUTLINE"]	= L["Thick"],
							}
						},
						fontSize = {
							type = "range",
							order = 3,
							name = L["Font Size"],
							desc = L["Global font size."],
							min = 9, max = 48, step = 1,
							get = function() return db.general.fontSize end,
							set = function(_, value) db.general.fontSize = value end,
						},
						fontColor = {
							type = "color",
							order = 4,
							name = L["Global Font Color"],
							desc = L["Color of the global font."],
							get = function(info)
								local t = db.general.fontColor
								return t.r, t.g, t.b
							end,
							set = function(info, r, g, b)
								db.general.fontColor = {
									r = r,
									g = g,
									b = b,
								}
							end,
						},
					},
				},
			},
		},
		warning = {
			type = "group",
			name = L["Warning Settings"],
			order = 2,
			childGroups = "tab",
			args = {
				autoDisable = {
					type = "toggle",
					order = 1,
					name = L["Auto Disable"],
					desc = L["Automatically disable the executes if you're not Affliction, or are not talented for Decimation or Shadowburn."],
					get = function() return db.warning.autoDisable end,
					set = function(_, value)
						db.warning.autoDisable = value
						if db.warning.autoDisable then
							db.warning.drainSoul.enabled	= isAffliction()
							db.warning.decimation.enabled	= hasDecimation()
							db.warning.shadowBurn.enabled	= hasShadowburn() 
						end
					end,
				},
				test = {
					type = "execute",
					order = 2,
					name = L["Test Execute Warning"],
					desc = L["Test your execute warning settings."],
					func = function()
						if db.warning.drainSoul.enabled then doExecuteWarning("drainSoul") end
						if db.warning.decimation.enabled then doExecuteWarning("decimation") end
						if db.warning.shadowBurn.enabled then doExecuteWarning("shadowBurn") end
					end,
				},
				drainSoul = {
					type = "group",
					order = 3,
					name = L["Drain Soul"],
					desc = L["Drain Soul execute warnings."],
					args = {
						generalSettings = {
							type = "group",
							order = 3,
							name = L["General Settings"],
							args = {
								enabled = {
									type = "toggle",
									order = 1,
									name = L["Enabled"],
									desc = L["Enable or disable the execute warning."],
									get = function() return db.warning.drainSoul.enabled end,
									set = function(_, value) db.warning.drainSoul.enabled = value end,
								},
								enableText = {
									type = "toggle",
									order = 2,
									name = L["Enable Warning Text"],
									desc = L["Enable or disable the warning text."],
									width = "double",
									get = function() return db.warning.drainSoul.enableText end,
									set = function(_, value)
										db.warning.drainSoul.enableText = value
										if value and db.warning.drainSoul.centerIcon then db.warning.drainSoul.centerIcon = false end
									end,
								},
								warningText = {
									type = "input",
									order = 3,
									name = L["Warning Text"],
									desc = L["Warning text to display when your target is in execute range."],
									disabled = function() return not db.warning.drainSoul.enableText end,
									get = function() return db.warning.drainSoul.warningText end,
									set = function(_, value) db.warning.drainSoul.warningText = value end,
								},
								warningPercent = {
									type = "range",
									order = 4,
									name = L["Warning Percent"],
									desc = L["Health percent to warn you."],
									min = 10, max = 40, step = 5,
									get = function() return db.warning.drainSoul.warningPercent end,
									set = function(_, value) db.warning.drainSoul.warningPercent = value end,
								},
								enableThreshold = {
									type = "toggle",
									order = 5,
									name = L["Enable Health Threshold"],
									desc = L["Enable the minimum health threshold."],
									get = function() return db.warning.drainSoul.enableThreshold end,
									set = function(_, value) db.warning.drainSoul.enableThreshold = value end,
								},
								minHealth = {
									type = "range",
									order = 6,
									name = L["Minimum HP"],
									desc = L["Minimum HP to activate execute range."],
									min = 90000, max = 500000, step = 1000,
									disabled = function() return not db.warning.drainSoul.enableThreshold end,
									get = function() return db.warning.drainSoul.minHealth end,
									set = function(_, value) db.warning.drainSoul.minHealth = value end,
								},
							},
						},
						iconSettings = {
							type = "group",
							order = 4,
							name = L["Icon Settings"],
							args = {
								icon = {
									type = "toggle",
									order = 3,
									name = L["Show Icon"],
									desc = L["Show icon next to the execute message."],
									get = function() return db.warning.drainSoul.icon end,
									set = function(_, value) db.warning.drainSoul.icon = value end,
								},
								iconid = {
									type = "input",
									order = 4,
									name = L["Icon ID"],
									desc = L["Icon of a spell to display."],
									width = "half",
									disabled = function() return not db.warning.drainSoul.icon end,
									get = function() return db.warning.drainSoul.iconid end,
									set = function(_, value) db.warning.drainSoul.iconid = value end,
								},
								iconView = {
									type = "description",
									name = "",
									order = 5,
									width = "half",
									image = function() return GetSpellTexture(db.warning.drainSoul.iconid) or GetSpellTexture(DRAIN_SOUL) end,
									imageWidth = 50,
									imageHeight = 50,
								},
							},
						},
						centerIconSettings = {
							type = "group",
							order = 5,
							name = L["Center Icon Settings"],
							args = {
								centerIcon = {
									type = "toggle",
									order = 1,
									name = L["Enable Center Icon"],
									desc = L["Display an icon in the center of the screen, instead of a text message."],
									get = function() return db.warning.drainSoul.centerIcon end,
									set = function(_, value)
										db.warning.drainSoul.centerIcon = value
										if value and db.warning.drainSoul.enableText then db.warning.drainSoul.enableText = false end
									end,
								},
								centerIconAlpha = {
									type = "range",
									order = 2,
									name = L["Center Icon Alpha"],
									desc = L["Set the transparency of the center icon."],
									disabled = function() return not db.warning.drainSoul.centerIcon end,
									min = 0, max = 1, step = 0.1,
									get = function() return db.warning.drainSoul.centerIconAlpha end,
									set = function(_, value) db.warning.drainSoul.centerIconAlpha = value end,
								},
								displayTime = {
									type = "input",
									order = 2,
									name = L["Display Time"],
									desc = L["Time, in seconds, to display the center icon."],
									disabled = function() return not db.warning.drainSoul.centerIcon end,
									get = function() return db.warning.drainSoul.displayTime end,
									set = function(_, value) db.warning.drainSoul.displayTime = value end,
								},
								centerIconID = {
									type = "input",
									order = 3,
									name = L["Center Icon ID"],
									desc = L["Icon of a spell to display."],
									width = "half",
									disabled = function() return not db.warning.drainSoul.centerIcon end,
									get = function() return db.warning.drainSoul.centerIconID end,
									set = function(_, value) db.warning.drainSoul.centerIconID = value end,
								},
								centerIconView = {
									type = "description",
									name = "",
									order = 4,
									width = "half",
									image = function() return GetSpellTexture(db.warning.drainSoul.centerIconID) or GetSpellTexture(DRAIN_SOUL) end,
									imageWidth = 50,
									imageHeight = 50,
								},
								centerIconX = {
									type = "input",
									name = L["X Offset"],
									desc = L["The X-axis offest, in pixels, for the center icon."],
									disabled = function() return not db.warning.drainSoul.centerIcon end,
									get = function() return db.warning.drainSoul.centerIconX end,
									set = function(_, value) db.warning.drainSoul.centerIconX = value end,
								},
								centerIconY = {
									type = "input",
									name = L["Y Offset"],
									desc = L["The Y-axis offset, in pixels, for the center icon."],
									disabled = function() return not db.warning.drainSoul.centerIcon end,
									get = function() return db.warning.drainSoul.centerIconY end,
									set = function(_, value) db.warning.drainSoul.centerIconY = value end,
								},
							},
						},
						soundSettings = {
							type = "group",
							order = 6,
							name = L["Sound Settings"],
							args = {
								playWarning = {
									type = "toggle",
									order = 1,
									name = L["Play Warning Sound"],
									desc = L["Play a sound when your target is in execute range."],
									get = function() return db.warning.drainSoul.playWarning end,
									set = function(_, value) db.warning.drainSoul.playWarning = value end,
								},
								sound = {
									type = "select", dialogControl = 'LSM30_Sound',
									order = 2,
									name = L["Execute Sound"],
									desc = L["Sound to be played for execute warning."],
									values = AceGUIWidgetLSMlists.sound,
									get = function() return db.warning.drainSoul.sound end,
									set = function(_, value) db.warning.drainSoul.sound = value end,
									disabled = function() return not db.warning.drainSoul.playWarning end,
								},
							},
						},
						fontSettings = {
							type = "group",
							name = L["Font Settings"],
							order = 6,
							disabled = function() return db.general.globalFont end,
							args = {
								fontFace = {
									type = "select", dialogControl = "LSM30_Font",
									order = 1,
									name = L["Font"],
									desc = L["The font to use for the execute warning."],
									values = AceGUIWidgetLSMlists.font,
									get = function() return db.warning.drainSoul.fontFace end,
									set = function(_, value) db.warning.drainSoul.fontFace = value end,
								},
								fontOutline = {
									type = "select",
									order = 2,
									name = L["Font Outline"],
									desc = L["Outline of the font."],
									get = function() return db.warning.drainSoul.fontOutline end,
									set = function(_, value) db.warning.drainSoul.fontOutline = value end,
									values = {
										["NORMAL"] 			= L["Normal"],
										["OUTLINE"]			= L["Outline"],
										["THICKOUTLINE"]	= L["Thick"],
									}
								},
								fontSize = {
									type = "range",
									order = 3,
									name = L["Font Size"],
									desc = L["Font Size of execute warnings."],
									min = 9, max = 48, step = 1,
									get = function() return db.warning.drainSoul.fontSize end,
									set = function(_, value) db.warning.drainSoul.fontSize = value end,
								},
								fontColor = {
									type = "color",
									order = 4,
									name = L["Warning Color"],
									desc = L["Color of the execute warning text."],
									get = function(info)
										local t = db.warning.drainSoul.fontColor
										return t.r, t.g, t.b
									end,
									set = function(info, r, g, b)
										db.warning.drainSoul.fontColor = {
											r = r,
											g = g,
											b = b,
										}
									end,
								},
							},
						},
					},
				},
				decimation = {
					type = "group",
					order = 4,
					name = L["Decimation"],
					desc = L["Decimation warnings."],
					args = {
						generalSettings = {
							type = "group",
							order = 3,
							name = L["General Settings"],
							args = {
								enabled = {
									type = "toggle",
									order = 1,
									name = L["Enabled"],
									desc = L["Enable or disable the execute warning."],
									get = function() return db.warning.decimation.enabled end,
									set = function(_, value) db.warning.decimation.enabled = value end,
								},
								enableText = {
									type = "toggle",
									order = 2,
									name = L["Enable Warning Text"],
									desc = L["Enable or disable the warning text."],
									width = "double",
									get = function() return db.warning.decimation.enableText end,
									set = function(_, value)
										db.warning.decimation.enableText = value
										if value and db.warning.decimation.centerIcon then db.warning.decimation.centerIcon = false end
									end,
								},
								warningText = {
									type = "input",
									order = 3,
									name = L["Warning Text"],
									desc = L["Warning text to display when your target is in execute range."],
									disabled = function() return not db.warning.decimation.enableText end,
									get = function() return db.warning.decimation.warningText end,
									set = function(_, value) db.warning.decimation.warningText = value end,
								},
							},
						},
						iconSettings = {
							type = "group",
							order = 4,
							name = L["Icon Settings"],
							args = {
								icon = {
									type = "toggle",
									order = 3,
									name = L["Show Icon"],
									desc = L["Show icon next to the execute message."],
									get = function() return db.warning.decimation.icon end,
									set = function(_, value) db.warning.decimation.icon = value end,
								},
								iconid = {
									type = "input",
									order = 4,
									name = L["Icon ID"],
									desc = L["Icon of a spell to display."],
									width = "half",
									disabled = function() return not db.warning.decimation.icon end,
									get = function() return db.warning.decimation.iconid end,
									set = function(_, value) db.warning.decimation.iconid = value end,
								},
								iconView = {
									type = "description",
									name = "",
									order = 5,
									width = "half",
									image = function() return GetSpellTexture(db.warning.decimation.iconid) or GetSpellTexture(DRAIN_SOUL) end,
									imageWidth = 50,
									imageHeight = 50,
								},
							},
						},
						centerIconSettings = {
							type = "group",
							order = 5,
							name = L["Center Icon Settings"],
							args = {
								centerIcon = {
									type = "toggle",
									order = 1,
									name = L["Enable Center Icon"],
									desc = L["Display an icon in the center of the screen, instead of a text message."],
									get = function() return db.warning.decimation.centerIcon end,
									set = function(_, value)
										db.warning.decimation.centerIcon = value
										if value and db.warning.decimation.enableText then db.warning.decimation.enableText = false end
									end,
								},
								centerIconAlpha = {
									type = "range",
									order = 2,
									name = L["Center Icon Alpha"],
									desc = L["Set the transparency of the center icon."],
									disabled = function() return not db.warning.decimation.centerIcon end,
									min = 0, max = 1, step = 0.1,
									get = function() return db.warning.decimation.centerIconAlpha end,
									set = function(_, value) db.warning.decimation.centerIconAlpha = value end,
								},
								displayTime = {
									type = "input",
									order = 2,
									name = L["Display Time"],
									desc = L["Time, in seconds, to display the center icon."],
									disabled = function() return not db.warning.decimation.centerIcon end,
									get = function() return db.warning.decimation.displayTime end,
									set = function(_, value) db.warning.decimation.displayTime = value end,
								},
								centerIconID = {
									type = "input",
									order = 3,
									name = L["Center Icon ID"],
									desc = L["Icon of a spell to display."],
									width = "half",
									disabled = function() return not db.warning.decimation.centerIcon end,
									get = function() return db.warning.decimation.centerIconID end,
									set = function(_, value) db.warning.decimation.centerIconID = value end,
								},
								centerIconView = {
									type = "description",
									name = "",
									order = 4,
									width = "half",
									image = function() return GetSpellTexture(db.warning.decimation.centerIconID) or GetSpellTexture(DRAIN_SOUL) end,
									imageWidth = 50,
									imageHeight = 50,
								},
								centerIconX = {
									type = "input",
									name = L["X Offset"],
									desc = L["The X-axis offest, in pixels, for the center icon."],
									disabled = function() return not db.warning.decimation.centerIcon end,
									get = function() return db.warning.decimation.centerIconX end,
									set = function(_, value) db.warning.decimation.centerIconX = value end,
								},
								centerIconY = {
									type = "input",
									name = L["Y Offset"],
									desc = L["The Y-axis offset, in pixels, for the center icon."],
									disabled = function() return not db.warning.decimation.centerIcon end,
									get = function() return db.warning.decimation.centerIconY end,
									set = function(_, value) db.warning.decimation.centerIconY = value end,
								},
							},
						},
						soundSettings = {
							type = "group",
							order = 6,
							name = L["Sound Settings"],
							args = {
								playWarning = {
									type = "toggle",
									order = 1,
									name = L["Play Warning Sound"],
									desc = L["Play a sound when your target is in execute range."],
									get = function() return db.warning.decimation.playWarning end,
									set = function(_, value) db.warning.decimation.playWarning = value end,
								},
								sound = {
									type = "select", dialogControl = 'LSM30_Sound',
									order = 2,
									name = L["Execute Sound"],
									desc = L["Sound to be played for execute warning."],
									values = AceGUIWidgetLSMlists.sound,
									get = function() return db.warning.decimation.sound end,
									set = function(_, value) db.warning.decimation.sound = value end,
									disabled = function() return not db.warning.decimation.playWarning end,
								},
							},
						},
						fontSettings = {
							type = "group",
							name = L["Font Settings"],
							order = 6,
							disabled = function() return db.general.globalFont end,
							args = {
								fontFace = {
									type = "select", dialogControl = "LSM30_Font",
									order = 1,
									name = L["Font"],
									desc = L["The font to use for the execute warning."],
									values = AceGUIWidgetLSMlists.font,
									get = function() return db.warning.decimation.fontFace end,
									set = function(_, value) db.warning.decimation.fontFace = value end,
								},
								fontOutline = {
									type = "select",
									order = 2,
									name = L["Font Outline"],
									desc = L["Outline of the font."],
									get = function() return db.warning.decimation.fontOutline end,
									set = function(_, value) db.warning.decimation.fontOutline = value end,
									values = {
										["NORMAL"] 			= L["Normal"],
										["OUTLINE"]			= L["Outline"],
										["THICKOUTLINE"]	= L["Thick"],
									}
								},
								fontSize = {
									type = "range",
									order = 3,
									name = L["Font Size"],
									desc = L["Font Size of execute warnings."],
									min = 9, max = 48, step = 1,
									get = function() return db.warning.decimation.fontSize end,
									set = function(_, value) db.warning.decimation.fontSize = value end,
								},
								fontColor = {
									type = "color",
									order = 4,
									name = L["Warning Color"],
									desc = L["Color of the execute warning text."],
									get = function(info)
										local t = db.warning.decimation.fontColor
										return t.r, t.g, t.b
									end,
									set = function(info, r, g, b)
										db.warning.decimation.fontColor = {
											r = r,
											g = g,
											b = b,
										}
									end,
								},
							},
						},
					},
				},
				shadowBurn = {
					type = "group",
					order = 5,
					name = L["Shadowburn"],
					desc = L["Shadowburn warnings."],
					args = {
						generalSettings = {
							type = "group",
							order = 3,
							name = L["General Settings"],
							args = {
								enabled = {
									type = "toggle",
									order = 1,
									name = L["Enabled"],
									desc = L["Enable or disable the execute warning."],
									get = function() return db.warning.shadowBurn.enabled end,
									set = function(_, value) db.warning.shadowBurn.enabled = value end,
								},
								enableText = {
									type = "toggle",
									order = 2,
									name = L["Enable Warning Text"],
									desc = L["Enable or disable the warning text."],
									width = "double",
									get = function() return db.warning.shadowBurn.enableText end,
									set = function(_, value)
										db.warning.shadowBurn.enableText = value
										if value and db.warning.shadowBurn.centerIcon then db.warning.shadowBurn.centerIcon = false end
									end,
								},
								warningText = {
									type = "input",
									order = 3,
									name = L["Warning Text"],
									desc = L["Warning text to display when your target is in execute range."],
									disabled = function() return not db.warning.shadowBurn.enableText end,
									get = function() return db.warning.shadowBurn.warningText end,
									set = function(_, value) db.warning.shadowBurn.warningText = value end,
								},
								warningPercent = {
									type = "range",
									order = 4,
									name = L["Warning Percent"],
									desc = L["Health percent to warn you."],
									min = 10, max = 40, step = 5,
									get = function() return db.warning.shadowBurn.warningPercent end,
									set = function(_, value) db.warning.shadowBurn.warningPercent = value end,
								},
								enableThreshold = {
									type = "toggle",
									order = 5,
									name = L["Enable Health Threshold"],
									desc = L["Enable the minimum health threshold."],
									get = function() return db.warning.shadowBurn.enableThreshold end,
									set = function(_, value) db.warning.shadowBurn.enableThreshold = value end,
								},
								minHealth = {
									type = "range",
									order = 6,
									name = L["Minimum HP"],
									desc = L["Minimum HP to activate execute range."],
									min = 90000, max = 500000, step = 1000,
									disabled = function() return not db.warning.shadowBurn.enableThreshold end,
									get = function() return db.warning.shadowBurn.minHealth end,
									set = function(_, value) db.warning.shadowBurn.minHealth = value end,
								},
							},
						},
						iconSettings = {
							type = "group",
							order = 4,
							name = L["Icon Settings"],
							args = {
								icon = {
									type = "toggle",
									order = 3,
									name = L["Show Icon"],
									desc = L["Show icon next to the execute message."],
									get = function() return db.warning.shadowBurn.icon end,
									set = function(_, value) db.warning.shadowBurn.icon = value end,
								},
								iconid = {
									type = "input",
									order = 4,
									name = L["Icon ID"],
									desc = L["Icon of a spell to display."],
									width = "half",
									disabled = function() return not db.warning.shadowBurn.icon end,
									get = function() return db.warning.shadowBurn.iconid end,
									set = function(_, value) db.warning.shadowBurn.iconid = value end,
								},
								iconView = {
									type = "description",
									name = "",
									order = 5,
									width = "half",
									image = function() return GetSpellTexture(db.warning.shadowBurn.iconid) or GetSpellTexture(DRAIN_SOUL) end,
									imageWidth = 50,
									imageHeight = 50,
								},
							},
						},
						centerIconSettings = {
							type = "group",
							order = 5,
							name = L["Center Icon Settings"],
							args = {
								centerIcon = {
									type = "toggle",
									order = 1,
									name = L["Enable Center Icon"],
									desc = L["Display an icon in the center of the screen, instead of a text message."],
									get = function() return db.warning.shadowBurn.centerIcon end,
									set = function(_, value)
										db.warning.shadowBurn.centerIcon = value
										if value and db.warning.shadowBurn.enableText then db.warning.shadowBurn.enableText = false end
									end,
								},
								centerIconAlpha = {
									type = "range",
									order = 2,
									name = L["Center Icon Alpha"],
									desc = L["Set the transparency of the center icon."],
									disabled = function() return not db.warning.shadowBurn.centerIcon end,
									min = 0, max = 1, step = 0.1,
									get = function() return db.warning.shadowBurn.centerIconAlpha end,
									set = function(_, value) db.warning.shadowBurn.centerIconAlpha = value end,
								},
								displayTime = {
									type = "input",
									order = 2,
									name = L["Display Time"],
									desc = L["Time, in seconds, to display the center icon."],
									disabled = function() return not db.warning.shadowBurn.centerIcon end,
									get = function() return db.warning.shadowBurn.displayTime end,
									set = function(_, value) db.warning.shadowBurn.displayTime = value end,
								},
								centerIconID = {
									type = "input",
									order = 3,
									name = L["Center Icon ID"],
									desc = L["Icon of a spell to display."],
									width = "half",
									disabled = function() return not db.warning.shadowBurn.centerIcon end,
									get = function() return db.warning.shadowBurn.centerIconID end,
									set = function(_, value) db.warning.shadowBurn.centerIconID = value end,
								},
								centerIconView = {
									type = "description",
									name = "",
									order = 4,
									width = "half",
									image = function() return GetSpellTexture(db.warning.shadowBurn.centerIconID) or GetSpellTexture(DRAIN_SOUL) end,
									imageWidth = 50,
									imageHeight = 50,
								},
								centerIconX = {
									type = "input",
									name = L["X Offset"],
									desc = L["The X-axis offest, in pixels, for the center icon."],
									disabled = function() return not db.warning.shadowBurn.centerIcon end,
									get = function() return db.warning.shadowBurn.centerIconX end,
									set = function(_, value) db.warning.shadowBurn.centerIconX = value end,
								},
								centerIconY = {
									type = "input",
									name = L["Y Offset"],
									desc = L["The Y-axis offset, in pixels, for the center icon."],
									disabled = function() return not db.warning.shadowBurn.centerIcon end,
									get = function() return db.warning.shadowBurn.centerIconY end,
									set = function(_, value) db.warning.shadowBurn.centerIconY = value end,
								},
							},
						},
						soundSettings = {
							type = "group",
							order = 6,
							name = L["Sound Settings"],
							args = {
								playWarning = {
									type = "toggle",
									order = 1,
									name = L["Play Warning Sound"],
									desc = L["Play a sound when your target is in execute range."],
									get = function() return db.warning.shadowBurn.playWarning end,
									set = function(_, value) db.warning.shadowBurn.playWarning = value end,
								},
								sound = {
									type = "select", dialogControl = 'LSM30_Sound',
									order = 2,
									name = L["Execute Sound"],
									desc = L["Sound to be played for execute warning."],
									values = AceGUIWidgetLSMlists.sound,
									get = function() return db.warning.shadowBurn.sound end,
									set = function(_, value) db.warning.shadowBurn.sound = value end,
									disabled = function() return not db.warning.shadowBurn.playWarning end,
								},
							},
						},
						fontSettings = {
							type = "group",
							name = L["Font Settings"],
							order = 6,
							disabled = function() return db.general.globalFont end,
							args = {
								fontFace = {
									type = "select", dialogControl = "LSM30_Font",
									order = 1,
									name = L["Font"],
									desc = L["The font to use for the execute warning."],
									values = AceGUIWidgetLSMlists.font,
									get = function() return db.warning.shadowBurn.fontFace end,
									set = function(_, value) db.warning.shadowBurn.fontFace = value end,
								},
								fontOutline = {
									type = "select",
									order = 2,
									name = L["Font Outline"],
									desc = L["Outline of the font."],
									get = function() return db.warning.shadowBurn.fontOutline end,
									set = function(_, value) db.warning.shadowBurn.fontOutline = value end,
									values = {
										["NORMAL"] 			= L["Normal"],
										["OUTLINE"]			= L["Outline"],
										["THICKOUTLINE"]	= L["Thick"],
									}
								},
								fontSize = {
									type = "range",
									order = 3,
									name = L["Font Size"],
									desc = L["Font Size of execute warnings."],
									min = 9, max = 48, step = 1,
									get = function() return db.warning.shadowBurn.fontSize end,
									set = function(_, value) db.warning.shadowBurn.fontSize = value end,
								},
								fontColor = {
									type = "color",
									order = 4,
									name = L["Warning Color"],
									desc = L["Color of the execute warning text."],
									get = function(info)
										local t = db.warning.shadowBurn.fontColor
										return t.r, t.g, t.b
									end,
									set = function(info, r, g, b)
										db.warning.shadowBurn.fontColor = {
											r = r,
											g = g,
											b = b,
										}
									end,
								},
							},
						},
					},
				},
			},
		},
		ticks = {
			type = "group",
			name = L["Tick Settings"],
			order = 3,
			childGroups = "tab",
			args = {
				test = {
					type = "execute",
					order = 1,
					name = L["Test Tick Settings"],
					func = function()
						-- drain soul test
						if db.ticks.drainSoul.enabled then doSpellTick("drainSoul", 13370) end
						
						-- drain life test
						if db.ticks.drainLife.enabled then doSpellTick("drainLife", 13370) end
					end,
				},
				drainSoul = {
					type = "group",
					order = 2,
					name = L["Drain Soul"],
					desc = L["Drain Soul tick monitor."],
					args = {
						generalSettings = {
							type = "group",
							order = 1,
							name = L["General Settings"],
							args = {
								enabled = {
									type = "toggle",
									order = 1,
									name = L["Enabled"],
									desc = L["Toggle Drain Soul tick notifications."],
									get = function() return db.ticks.drainSoul.enabled end,
									set = function(_, value) db.ticks.drainSoul.enabled = value end,
								},
								enableText = {
									type = "toggle",
									order = 2,
									name = L["Enable Tick Text"],
									desc = L["Enable or disable the text message when Drain Soul ticks."],
									get = function() return db.ticks.drainSoul.enableText end,
									set = function(_, value) db.ticks.drainSoul.enableText = value end,
								},
								tickText = {
									type = "input",
									order = 3,
									name = L["Tick Text"],
									desc = L["Text to display when Drain Soul ticks."],
									disabled = function() return not db.ticks.drainSoul.enableText end,
									get = function() return db.ticks.drainSoul.tickText end,
									set = function(_, value) db.ticks.drainSoul.tickText = value end,
								},
								tickDamage = {
									type = "toggle",
									order = 4,
									name = L["Show Tick Damage"],
									desc = L["Show tick damage when displaying ticks."],
									disabled = function() return not db.ticks.drainSoul.enableText end,
									get = function() return db.ticks.drainSoul.tickDamage end,
									set = function(_, value) db.ticks.drainSoul.tickDamage = value end,
								},
							},
						},
						iconSettings = {
							type = "group",
							order = 2,
							name = L["Icon Settings"],
							args = {
								icon = {
									type = "toggle",
									order = 1,
									name = L["Show Icon"],
									desc = L["Show icon next to the execute message."],
									get = function() return db.ticks.drainSoul.icon end,
									set = function(_, value) db.ticks.drainSoul.icon = value end,
								},
								iconid = {
									type = "input",
									order = 2,
									name = L["Icon ID"],
									desc = L["Icon of a spell to display."],
									width = "half",
									disabled = function() return not db.ticks.drainSoul.icon end,
									get = function() return db.ticks.drainSoul.iconid end,
									set = function(_, value) db.ticks.drainSoul.iconid = value end,
								},
								iconView = {
									type = "description",
									name = "",
									order = 3,
									width = "half",
									image = function() return GetSpellTexture(db.ticks.drainSoul.iconid) or GetSpellTexture(DRAIN_SOUL) end,
									imageWidth = 50,
									imageHeight = 50,
								},
							},
						},
						soundSettings = {
							type = "group",
							order = 3,
							name = L["Sound Settings"],
							args = {
								playTick = {
									type = "toggle",
									order = 1,
									name = L["Play Tick Sound"],
									desc = L["Play a sound when Drain Soul ticks."],
									get = function() return db.ticks.drainSoul.playTick end,
									set = function(_, value) db.ticks.drainSoul.playTick = value end,
								},
								sound = {
									type = "select", dialogControl = 'LSM30_Sound',
									order = 2,
									name = L["Tick Sound"],
									desc = L["Sound to play when Drain Soul ticks."],
									values = AceGUIWidgetLSMlists.sound,
									get = function() return db.ticks.drainSoul.sound end,
									set = function(_, value) db.ticks.drainSoul.sound = value end,
									disabled = function() return not db.ticks.drainSoul.playTick end,
								},
							},
						},
						fontSettings = {
							type = "group",
							name = L["Font Settings"],
							order = 4,
							disabled = function() return db.general.globalFont end,
							args = {
								fontFace = {
									type = "select", dialogControl = "LSM30_Font",
									order = 1,
									name = L["Font"],
									desc = L["The font to use for the execute warning."],
									values = AceGUIWidgetLSMlists.font,
									get = function() return db.ticks.drainSoul.fontFace end,
									set = function(_, value) db.ticks.drainSoul.fontFace = value end,
								},
								fontOutline = {
									type = "select",
									order = 2,
									name = L["Font Outline"],
									desc = L["Outline of the font."],
									get = function() return db.ticks.drainSoul.fontOutline end,
									set = function(_, value) db.ticks.drainSoul.fontOutline = value end,
									values = {
										["NORMAL"] 			= L["Normal"],
										["OUTLINE"]			= L["Outline"],
										["THICKOUTLINE"]	= L["Thick"],
									}
								},
								fontSize = {
									type = "range",
									order = 3,
									name = L["Font Size"],
									desc = L["Font Size of execute warnings."],
									min = 9, max = 48, step = 1,
									get = function() return db.ticks.drainSoul.fontSize end,
									set = function(_, value) db.ticks.drainSoul.fontSize = value end,
								},
								fontColor = {
									type = "color",
									order = 4,
									name = L["Font Color"],
									desc = L["Color of the execute warning text."],
									get = function(info)
										local t = db.ticks.drainSoul.fontColor
										return t.r, t.g, t.b
									end,
									set = function(info, r, g, b)
										db.ticks.drainSoul.fontColor = {
											r = r,
											g = g,
											b = b,
										}
									end,
								},
							},
						},
					},
				},
				drainLife = {
					type = "group",
					name = L["Drain Life"],
					desc = L["Drain Life tick monitor."],
					order = 3,
					args = {
						generalSettings = {
							type = "group",
							order = 1,
							name = L["General Settings"],
							args = {
								enabled = {
									type = "toggle",
									order = 1,
									name = L["Enabled"],
									desc = L["Toggle Drain Life tick notifications."],
									get = function() return db.ticks.drainLife.enabled end,
									set = function(_, value) db.ticks.drainLife.enabled = value end,
								},
								enableText = {
									type = "toggle",
									order = 2,
									name = L["Enable Tick Text"],
									desc = L["Enable or disable the text message when Drain Life ticks."],
									get = function() return db.ticks.drainLife.enableText end,
									set = function(_, value) db.ticks.drainLife.enableText = value end,
								},
								tickText = {
									type = "input",
									order = 3,
									name = L["Tick Text"],
									desc = L["Text to display when Drain Life ticks."],
									disabled = function() return not db.ticks.drainLife.enableText end,
									get = function() return db.ticks.drainLife.tickText end,
									set = function(_, value) db.ticks.drainLife.tickText = value end,
								},
								tickDamage = {
									type = "toggle",
									order = 4,
									name = L["Show Tick Damage"],
									desc = L["Show tick damage when displaying ticks."],
									disabled = function() return not db.ticks.drainLife.enableText end,
									get = function() return db.ticks.drainLife.tickDamage end,
									set = function(_, value) db.ticks.drainLife.tickDamage = value end,
								},
							},
						},
						iconSettings = {
							type = "group",
							order = 2,
							name = L["Icon Settings"],
							args = {
								icon = {
									type = "toggle",
									order = 1,
									name = L["Show Icon"],
									desc = L["Show icon next to the execute message."],
									get = function() return db.ticks.drainLife.icon end,
									set = function(_, value) db.ticks.drainLife.icon = value end,
								},
								iconid = {
									type = "input",
									order = 2,
									name = L["Icon ID"],
									desc = L["Icon of a spell to display."],
									width = "half",
									disabled = function() return not db.ticks.drainLife.icon end,
									get = function() return db.ticks.drainLife.iconid end,
									set = function(_, value) db.ticks.drainLife.iconid = value end,
								},
								iconView = {
									type = "description",
									name = "",
									order = 3,
									width = "half",
									image = function() return GetSpellTexture(db.ticks.drainLife.iconid) or GetSpellTexture(DRAIN_LIFE) end,
									imageWidth = 50,
									imageHeight = 50,
								},
							},
						},
						soundSettings = {
							type = "group",
							order = 3,
							name = L["Sound Settings"],
							args = {
								playTick = {
									type = "toggle",
									order = 1,
									name = L["Play Tick Sound"],
									desc = L["Play a sound when Drain Life ticks."],
									get = function() return db.ticks.drainLife.playTick end,
									set = function(_, value) db.ticks.drainLife.playTick = value end,
								},
								sound = {
									type = "select", dialogControl = 'LSM30_Sound',
									order = 2,
									name = L["Tick Sound"],
									desc = L["Sound to play when Drain Life ticks."],
									values = AceGUIWidgetLSMlists.sound,
									get = function() return db.ticks.drainLife.sound end,
									set = function(_, value) db.ticks.drainLife.sound = value end,
									disabled = function() return not db.ticks.drainLife.playTick end,
								},
							},
						},
						fontSettings = {
							type = "group",
							name = L["Font Settings"],
							order = 4,
							disabled = function() return db.general.globalFont end,
							args = {
								fontFace = {
									type = "select", dialogControl = "LSM30_Font",
									order = 1,
									name = L["Font"],
									desc = L["The font to use for the execute warning."],
									values = AceGUIWidgetLSMlists.font,
									get = function() return db.ticks.drainLife.fontFace end,
									set = function(_, value) db.ticks.drainLife.fontFace = value end,
								},
								fontOutline = {
									type = "select",
									order = 2,
									name = L["Font Outline"],
									desc = L["Outline of the font."],
									get = function() return db.ticks.drainLife.fontOutline end,
									set = function(_, value) db.ticks.drainLife.fontOutline = value end,
									values = {
										["NORMAL"] 			= L["Normal"],
										["OUTLINE"]			= L["Outline"],
										["THICKOUTLINE"]	= L["Thick"],
									}
								},
								fontSize = {
									type = "range",
									order = 3,
									name = L["Font Size"],
									desc = L["Font Size of execute warnings."],
									min = 9, max = 48, step = 1,
									get = function() return db.ticks.drainLife.fontSize end,
									set = function(_, value) db.ticks.drainLife.fontSize = value end,
								},
								fontColor = {
									type = "color",
									order = 4,
									name = L["Font Color"],
									desc = L["Color of the execute warning text."],
									get = function(info)
										local t = db.ticks.drainLife.fontColor
										return t.r, t.g, t.b
									end,
									set = function(info, r, g, b)
										db.ticks.drainLife.fontColor = {
											r = r,
											g = g,
											b = b,
										}
									end,
								},
							},
						},
					},
				},
			},
		},
		announce = {
			type = "group",
			name = L["Announcements"],
			order = 4,
			args = {
				darkIntent = {
					type = "group",
					order = 1,
					name = L["Dark Intent"],
					desc = L["Dark Intent announcements."],
					args = {
						enabled = {
							type = "toggle",
							order = 1,
							name = L["Enabled"],
							desc = L["Enable or disable the Dark Intent announcements."],
							get = function() return db.announce.darkIntent.enabled end,
							set = function(_, value) db.announce.darkIntent.enabled = value end,
						},
						whisper = {
							type = "toggle",
							order = 2,
							name = L["Whisper Recipient"],
							desc = L["Whisper recipient of Dark Intent."],
							get = function() return db.announce.darkIntent.whisper end,
							set = function(_, value) db.announce.darkIntent.whisper = value end,
						},
						tooltip = {
							type = "toggle",
							order = 3,
							name = L["Hook Tooltip"],
							desc = L["Hook DI's tooltip to show who has your, or any other locks in your raid/party, DI."],
							width = "double",
							get = function() return db.announce.darkIntent.tooltip end,
							set = function(_, value)
								db.announce.darkIntent.tooltip = value
								if db.announce.darkIntent.tooltip then
									-- hook the tooltip
									GameTooltip:HookScript("OnTooltipSetSpell", function(self)
										local name, _, id = self:GetSpell()
										local tooltipLine = ""
										if #diTargets > 0 and (id == DARK_INTENT or id == DARK_INTENT_TARGET) then
											self:AddLine(" ")
											self:AddLine("|cffffffff" .. L["Dark Intent Targets"] .. "|r")
											i = 1
											for _, entry in pairs(diTargets) do
												tooltipLine = tooltipLine .. format("%s (%s)", entry.nameColored, entry.caster)
												if i ~= #diTargets then tooltipLine = tooltipLine .. ", " end
												i = i + 1
											end
											self:AddLine(tooltipLine)
											self:Show()
										end
									end)
								else
									GameTooltip:HookScript("OnTooltipSetSpell", function() end)
								end
							end,
						},
						output = {
							type = "input",
							order = 4,
							name = L["Text Output"],
							desc = L["Text to output to the channel.\n\n|cff00ff00{SPELL}|r denotes the spell link.\n|cff00ff00{TARGET}|r denotes the target."],
							width = "double",
							get = function() return db.announce.darkIntent.output end,
							set = function(_, value) db.announce.darkIntent.output = value end,
						},
						refreshText = {
							type = "toggle",
							order = 5,
							name = L["Refresh Text"],
							desc = L["Enable or disable the announcement when Dark Intent is refreshed on the target."],
							width = "double",
							get = function() return db.announce.darkIntent.refreshText end,
							set = function(_, value) db.announce.darkIntent.refreshText = value end,
						},
						refresh = {
							type = "input",
							order = 6,
							name = L["Refresh DI Output"],
							desc = L["Text to output when you refresh your Dark Intent on someone.\n\n|cff00ff00{SPELL}|r denotes the spell link.\n|cff00ff00{TARGET}|r denotes the target."],
							width = "double",
							disabled = function() return not db.announce.darkIntent.refreshText end,
							get = function() return db.announce.darkIntent.refresh end,
							set = function(_, value) db.announce.darkItent.refresh = value end,
						},
						channel = {
							type = "select",
							order = 7,
							name = L["Output Channel"],
							desc = L["Channel to output the Dark Intent announcements to."],
							width = "double",
							get = function() return db.announce.darkIntent.channel end,
							set = function(_, value) db.announce.darkIntent.channel = value end,
							values = {
								["NONE"]			= L["None"],
								["CHATFRAME"]		= L["Default"],
								["RAID"]			= L["Raid"],
								["RAID_WARNING"]	= L["Raid Warning"],
								["PARTY"]			= L["Party"],
								["SAY"]				= L["Say"],
								["YELL"]			= L["Yell"],
							},
						},
					},
				},
				soulstone = {
					type = "group",
					order = 2,
					name = L["Soulstone"],
					desc = L["Tracks soulstone cooldown and target."],
					args = {
						enabled = {
							type = "toggle",
							order = 1,
							name = L["Enabled"],
							desc = L["Enable or disable the Soulstone Resurrection tracking."],
							width = "double",
							get = function() return db.announce.soulstone.enabled end,
							set = function(_, value) db.announce.soulstone.enabled = value end,
						},
						whisper = {
							type = "toggle",
							order = 2,
							name = L["Whisper Soulstone Target"],
							desc = L["Whisper your soulstone target when the Soulstone Resurrection cast is successful.\n\n|cff00f00{CASTER}|r denotes the caster's name."],
							width = "double",
							disabled = function() return not db.announce.soulstone.enabled end,
							get = function() return db.announce.soulstone.whisper end,
							set = function(_, value) db.announce.soulstone.whisper = value end,
						},
						whisperText = {
							type = "input",
							order = 3,
							name = L["Whisper Text"],
							desc = L["Text to whisper the target when Soulstone is casted successfully on them."],
							width = "double",
							disabled = function() return not db.announce.soulstone.whisper end,
							get = function() return db.announce.soulstone.whisperText end,
							set = function(_, value) db.announce.soulstone.whisperText = value end,
						},
						start = {
							type = "toggle",
							order = 4,
							name = L["Announce Cast Start"],
							desc = L["Announce when the Soulstone Resurrection cast is started."],
							width = "double",
							disabled = function() return not db.announce.soulstone.enabled end,
							get = function() return db.announce.soulstone.success end,
							set = function(_, value) db.announce.soulstone.success = value end,
						},
						startText = {
							type = "input",
							order = 5,
							name = L["Cast Start Text"],
							desc = L["Text to announce when the Soulstone Resurrection cast is started.\n\n|cff00ff00{SPELL}|r denotes the spell link.\n|cff00ff00{TARGET}|r denotes the target's name."],
							width = "double",
							disabled = function() return not db.announce.soulstone.start end,
							get = function() return db.announce.soulstone.startText end,
							set = function(_, value) db.announce.soulstone.startText = value end,
						},
						fail = {
							type = "toggle",
							order = 6,
							name = L["Announce Failed Cast"],
							desc = L["Announce when the Soulstone Resurrection cast is cancelled."],
							width = "double",
							disabled = function() return not db.announce.soulstone.enabled end,
							get = function() return db.announce.soulstone.fail end,
							set = function(_, value) db.announce.soulstone.fail = value end,
						},
						failText = {
							type = "input",
							order = 7,
							name = L["Cast Fail Text"],
							desc = L["Text to announce when the Soulstone Resurrection cast is cancelled.\n\n|cff00ff00{SPELL}|r denotes the spell link.\n|cff00ff00{TARGET}|r denotes the target's name."],
							width = "double",
							disabled = function() return not db.announce.soulstone.fail end,
							get = function() return db.announce.soulstone.failText end,
							set = function(_, value) db.announce.soulstone.failText = value end,
						},
						success = {
							type = "toggle",
							order = 8,
							name = L["Announce Successful Cast"],
							desc = L["Announce when the Soulstone Resurrection cast is successful."],
							width = "double",
							disabled = function() return not db.announce.soulstone.enabled end,
							get = function() return db.announce.soulstone.success end,
							set = function(_, value) db.announce.soulstone.success = value end,
						},
						successText = {
							type = "input",
							order = 9,
							name = L["Successful Cast Text"],
							desc = L["Text to announce when the Soulstone Resurrection cast is successful.\n\n|cff00ff00{SPELL}|r denotes the spell link.\n|cff00ff00{TARGET}|r denotes the target's name."],
							width = "double",
							disabled = function() return not db.announce.soulstone.success end,
							get = function() return db.announce.soulstone.successText end,
							set = function(_, value) db.announce.soulstone.successText = value end,
						},
						channel = {
							type = "select",
							order = 10,
							name = L["Output Channel"],
							desc = L["Channel to output the Dark Intent announcements to."],
							get = function() return db.announce.soulstone.channel end,
							set = function(_, value) db.announce.soulstone.channel = value end,
							values = {
								["NONE"]			= L["None"],
								["CHATFRAME"]		= L["Default"],
								["RAID"]			= L["Raid"],
								["RAID_WARNING"]	= L["Raid Warning"],
								["PARTY"]			= L["Party"],
								["SAY"]				= L["Say"],
								["YELL"]			= L["Yell"],
							},
						},
					},
				},
				ritualOfSouls = {
					type = "group",
					order = 3,
					name = L["Ritual of Souls"],
					desc = L["Announces when you cast Ritual of Souls."],
					args = {
						enabled = {
							type = "toggle",
							order = 1,
							name = L["Enabled"],
							desc = L["Enable or disable the Ritual of Souls announcements."],
							get = function() return db.announce.ritualOfSouls.enabled end,
							set = function(_, value) db.announce.ritualOfSouls.enabled = value end,
						},
						channel = {
							type = "select",
							order = 2,
							name = L["Output Channel"],
							desc = L["Channel to output the Dark Intent announcements to."],
							get = function() return db.announce.ritualOfSouls.channel end,
							set = function(_, value) db.announce.ritualOfSouls.channel = value end,
							values = {
								["NONE"]			= L["None"],
								["CHATFRAME"]		= L["Default"],
								["RAID"]			= L["Raid"],
								["RAID_WARNING"]	= L["Raid Warning"],
								["PARTY"]			= L["Party"],
								["SAY"]				= L["Say"],
								["YELL"]			= L["Yell"],
							},
						},
						output = {
							type = "input",
							order = 3,
							name = L["Text Output"],
							desc = L["Text to output to the channel.\n\n|cff00ff00{SPELL}|r denotes the spell link."],
							width = "double",
							get = function() return db.announce.ritualOfSouls.output end,
							set = function(_, value) db.announce.ritualOfSouls.output = value end,
						},
					},
				},
				ritualOfSummoning = {
					type = "group",
					order = 4,
					name = L["Ritual of Summoning"],
					desc = L["Announces when you cast Ritual of Summoning."],
					args = {
						enabled = {
							type = "toggle",
							order = 1,
							name = L["Enabled"],
							desc = L["Enable or disable the Ritual of Summoning announcements."],
							get = function() return db.announce.ritualOfSummoning.enabled end,
							set = function(_, value) db.announce.ritualOfSummoning.enabled = value end,
						},
						channel = {
							type = "select",
							order = 2,
							name = L["Output Channel"],
							desc = L["Channel to output the Dark Intent announcements to."],
							get = function() return db.announce.ritualOfSummoning.channel end,
							set = function(_, value) db.announce.ritualOfSummoning.channel = value end,
							values = {
								["NONE"]			= L["None"],
								["CHATFRAME"]		= L["Default"],
								["RAID"]			= L["Raid"],
								["RAID_WARNING"]	= L["Raid Warning"],
								["PARTY"]			= L["Party"],
								["SAY"]				= L["Say"],
								["YELL"]			= L["Yell"],
							},
						},
						output = {
							type = "input",
							order = 3,
							name = L["Text Output"],
							desc = L["Text to output to the channel.\n\n|cff00ff00{SPELL}|r denotes the spell link."],
							width = "double",
							get = function() return db.announce.ritualOfSummoning.output end,
							set = function(_, value) db.announce.ritualOfSummoning.output = value end,
						},
					},
				},
			},
		},
		procs = {
			type = "group",
			name = L["Proc Announcements"],
			order = 5,
			childGroups = "tab",
			args = {
				autoDisable = {
					type = "toggle",
					order = 1,
					name = L["Auto Disable"],
					desc = L["Automatically disable the proc notifications based on your spec/talents."],
					get = function() return db.procs.autoDisable end,
					set = function(_, value)
						db.procs.autoDisable = value
						if db.procs.autoDisable then
							db.procs.backdraft.enabled		= hasBackdraft()
							db.procs.eradication.enabled	= hasEradication()
							db.procs.moltenCore.enabled		= hasMoltenCore()
							db.procs.nightfall.enabled		= hasNightfall()
							db.procs.impSoulFire.enabled	= hasImprovedSoulFire()
						end
					end,
				},
				test = {
					type = "execute",
					order = 2,
					name = L["Test Proc Notifications"],
					desc = L["Test your proc notficiation settings."],
					func = function()
						if db.procs.eradication.enabled then doNotification("procs", "eradication") end
						if db.procs.moltenCore.enabled then doNotification("procs", "moltenCore") end
						if db.procs.nightfall.enabled then doNotification("procs", "nightfall") end
					end,
				},
				backdraft = {
					type = "group",
					order = 3,
					name = L["Backdraft"],
					desc = L["Announce when Backdraft procs."],
					args = {
						generalSettings = {
							type = "group",
							order = 1,
							name = L["General Settings"],
							args = {
								enabled = {
									type = "toggle",
									order = 1,
									name = L["Enabled"],
									desc = L["Enable or disable the Backdraft proc notification."],
									width = "double",
									get = function() return db.procs.backdraft.enabled end,
									set = function(_, value) db.procs.backdraft.enabled = value end,
								},
								enableText = {
									type = "toggle",
									order = 2,
									name = L["Enable Proc Text"],
									desc = L["Enable or disable the text message when Backdraft procs."],
									get = function() return db.procs.backdraft.enableText end,
									set = function(_, value) db.procs.backdraft.enableText = value end,
								},
								output = {
									type = "input",
									order = 3,
									name = L["Output Text"],
									desc = L["Text to announce when Backdraft procs."],
									disabled = function() return not db.procs.backdraft.enableText end,
									get = function() return db.procs.backdraft.output end,
									set = function(_, value) db.procs.backdraft.output = value end,
								},
								fadedText = {
									type = "toggle",
									order = 4,
									name = L["Enable Faded Text"],
									desc = L["Enable or disable the text message when Backdraft fades."],
									get = function() return db.procs.backdraft.fadedText end,
									set = function(_, value) db.procs.backdraft.fadedText = value end,
								},
								fadedOutput = {
									type = "input",
									order = 5,
									name = L["Faded Output Text"],
									desc = L["Text to announce Backdraft fades."],
									get = function() return db.procs.backdraft.fadedOutput end,
									set = function(_, value) db.procs.backdraft.fadedOutput = value end,
								},
							}
						},
						iconSettings = {
							type = "group",
							order = 2,
							name = L["Icon Settings"],
							args = {
								icon = {
									type = "toggle",
									order = 3,
									name = L["Show Icon"],
									desc = L["Show icon next to the proc message."],
									get = function() return db.procs.backdraft.icon end,
									set = function(_, value) db.procs.backdraft.icon = value end,
								},
								iconid = {
									type = "input",
									order = 4,
									name = L["Icon ID"],
									desc = L["Icon of a spell to display."],
									width = "half",
									disabled = function() return not db.procs.backdraft.icon end,
									get = function() return db.procs.backdraft.iconid end,
									set = function(_, value) db.procs.backdraft.iconid = value end,
								},
								iconView = {
									type = "description",
									name = "",
									order = 5,
									width = "half",
									disabled = function() return not db.procs.backdraft.icon end,
									image = function() return GetSpellTexture(db.procs.backdraft.iconid) end,
									imageWidth = 50,
									imageHeight = 50,
								},
							},
						},
						soundSettings = {
							type = "group",
							order = 3,
							name = L["Sound Settings"],
							args = {
								playSound = {
									type = "toggle",
									order = 1,
									name = L["Play Tick Sound"],
									desc = L["Play a sound when Backdraft procs."],
									get = function() return db.procs.backdraft.playSound end,
									set = function(_, value) db.procs.backdraft.playSound = value end,
								},
								sound = {
									type = "select", dialogControl = 'LSM30_Sound',
									order = 2,
									name = L["Tick Sound"],
									desc = L["Sound to play when Backdraft procs."],
									values = AceGUIWidgetLSMlists.sound,
									get = function() return db.procs.backdraft.sound end,
									set = function(_, value) db.procs.backdraft.sound = value end,
									disabled = function() return not db.procs.backdraft.playSound end,
								},
							},
						},
						fontSettings = {
							type = "group",
							name = L["Font Settings"],
							order = 4,
							disabled = function() return db.general.globalFont end,
							args = {
								fontFace = {
									type = "select", dialogControl = "LSM30_Font",
									order = 1,
									name = L["Font"],
									desc = L["The font to use for the proc notification."],
									values = AceGUIWidgetLSMlists.font,
									get = function() return db.procs.backdraft.fontFace end,
									set = function(_, value) db.procs.backdraft.fontFace = value end,
								},
								fontOutline = {
									type = "select",
									order = 2,
									name = L["Font Outline"],
									desc = L["Outline of the font."],
									get = function() return db.procs.backdraft.fontOutline end,
									set = function(_, value) db.procs.backdraft.fontOutline = value end,
									values = {
										["NORMAL"] 			= L["Normal"],
										["OUTLINE"]			= L["Outline"],
										["THICKOUTLINE"]	= L["Thick"],
									}
								},
								fontSize = {
									type = "range",
									order = 3,
									name = L["Font Size"],
									desc = L["Font Size of proc notification."],
									min = 9, max = 48, step = 1,
									get = function() return db.procs.backdraft.fontSize end,
									set = function(_, value) db.procs.backdraft.fontSize = value end,
								},
								fontColor = {
									type = "color",
									order = 4,
									name = L["Font Color"],
									desc = L["Color of the proc notification text."],
									get = function(info)
										local t = db.procs.backdraft.fontColor
										return t.r, t.g, t.b
									end,
									set = function(info, r, g, b)
										db.procs.backdraft.fontColor = {
											r = r,
											g = g,
											b = b,
										}
									end,
								},
							},
						},
					},
				},
				eradication = {
					type = "group",
					order = 4,
					name = L["Eradication"],
					desc = L["Announce when Eradication procs."],
					args = {
						generalSettings = {
							type = "group",
							order = 1,
							name = L["General Settings"],
							args = {
								enabled = {
									type = "toggle",
									order = 1,
									name = L["Enabled"],
									desc = L["Enable or disable the Eradication proc notifications."],
									width = "double",
									get = function() return db.procs.eradication.enabled end,
									set = function(_, value) db.procs.eradication.enabled = value end,
								},
								enableText = {
									type = "toggle",
									order = 2,
									name = L["Enable Proc Text"],
									desc = L["Enable or disable the text message when Eradication procs."],
									get = function() return db.procs.eradication.enableText end,
									set = function(_, value) db.procs.eradication.enableText = value end,
								},
								output = {
									type = "input",
									order = 3,
									name = L["Output Text"],
									desc = L["Text to announce when Eradication procs."],
									width = "double",
									disabled = function() return not db.procs.eradication.enableText end,
									get = function() return db.procs.eradication.output end,
									set = function(_, value) db.procs.eradication.output = value end,
								},
							},
						},
						iconSettings = {
							type = "group",
							order = 2,
							name = L["Icon Settings"],
							args = {
								icon = {
									type = "toggle",
									order = 3,
									name = L["Show Icon"],
									desc = L["Show icon next to the proc message."],
									get = function() return db.procs.eradication.icon end,
									set = function(_, value) db.procs.eradication.icon = value end,
								},
								iconid = {
									type = "input",
									order = 4,
									name = L["Icon ID"],
									desc = L["Icon of a spell to display."],
									width = "half",
									disabled = function() return not db.procs.eradication.icon end,
									get = function() return db.procs.eradication.iconid end,
									set = function(_, value) db.procs.eradication.iconid = value end,
								},
								iconView = {
									type = "description",
									name = "",
									order = 5,
									width = "half",
									disabled = function() return not db.procs.eradication.icon end,
									image = function() return GetSpellTexture(db.procs.eradication.iconid) end,
									imageWidth = 50,
									imageHeight = 50,
								},
							},
						},
						soundSettings = {
							type = "group",
							order = 3,
							name = L["Sound Settings"],
							args = {
								playSound = {
									type = "toggle",
									order = 1,
									name = L["Play Tick Sound"],
									desc = L["Play a sound when Eradication procs."],
									get = function() return db.procs.eradication.playSound end,
									set = function(_, value) db.procs.eradication.playSound = value end,
								},
								sound = {
									type = "select", dialogControl = 'LSM30_Sound',
									order = 2,
									name = L["Tick Sound"],
									desc = L["Sound to play when Eradication procs."],
									values = AceGUIWidgetLSMlists.sound,
									get = function() return db.procs.eradication.sound end,
									set = function(_, value) db.procs.eradication.sound = value end,
									disabled = function() return not db.procs.eradication.playSound end,
								},
							},
						},
						fontSettings = {
							type = "group",
							name = L["Font Settings"],
							order = 4,
							disabled = function() return db.general.globalFont end,
							args = {
								fontFace = {
									type = "select", dialogControl = "LSM30_Font",
									order = 1,
									name = L["Font"],
									desc = L["The font to use for the proc notification."],
									values = AceGUIWidgetLSMlists.font,
									get = function() return db.procs.eradication.fontFace end,
									set = function(_, value) db.procs.eradication.fontFace = value end,
								},
								fontOutline = {
									type = "select",
									order = 2,
									name = L["Font Outline"],
									desc = L["Outline of the font."],
									get = function() return db.procs.eradication.fontOutline end,
									set = function(_, value) db.procs.eradication.fontOutline = value end,
									values = {
										["NORMAL"] 			= L["Normal"],
										["OUTLINE"]			= L["Outline"],
										["THICKOUTLINE"]	= L["Thick"],
									}
								},
								fontSize = {
									type = "range",
									order = 3,
									name = L["Font Size"],
									desc = L["Font Size of proc notification."],
									min = 9, max = 48, step = 1,
									get = function() return db.procs.eradication.fontSize end,
									set = function(_, value) db.procs.eradication.fontSize = value end,
								},
								fontColor = {
									type = "color",
									order = 4,
									name = L["Font Color"],
									desc = L["Color of the proc notification text."],
									get = function(info)
										local t = db.procs.eradication.fontColor
										return t.r, t.g, t.b
									end,
									set = function(info, r, g, b)
										db.procs.eradication.fontColor = {
											r = r,
											g = g,
											b = b,
										}
									end,
								},
							},
						},
					},
				},
				impSoulFire = {
					type = "group",
					order = 5,
					name = L["Improved Soul Fire"],
					desc = L["Announce when Improved Soul Fire procs."],
					args = {
						generalSettings = {
							type = "group",
							order = 1,
							name = L["General Settings"],
							args = {
								enabled = {
									type = "toggle",
									order = 1,
									name = L["Enabled"],
									desc = L["Enable or disable the Improved Soul Fire proc notifications."],
									width = "double",
									get = function() return db.procs.impSoulFire.enabled end,
									set = function(_, value) db.procs.impSoulFire.enabled = value end,
								},
								enableText = {
									type = "toggle",
									order = 2,
									name = L["Enable Proc Text"],
									desc = L["Enable or disable the text message when Improved Soul Fire procs."],
									get = function() return db.procs.impSoulFire.enableText end,
									set = function(_, value) db.procs.impSoulFire.enableText = value end,
								},
								output = {
									type = "input",
									order = 3,
									name = L["Output Text"],
									desc = L["Text to announce when Improved Soul Fire procs."],
									disabled = function() return not db.procs.impSoulFire.enableText end,
									get = function() return db.procs.impSoulFire.output end,
									set = function(_, value) db.procs.impSoulFire.output = value end,
								},
								fadedText = {
									type = "toggle",
									order = 4,
									name = L["Enable Faded Text"],
									desc = L["Enable or disable the text message when Improved Soul Fire fades."],
									get = function() return db.procs.impSoulFire.fadedText end,
									set = function(_, value) db.procs.impSoulFire.fadedText = value end,
								},
								fadedOutput = {
									type = "input",
									order = 5,
									name = L["Faded Output Text"],
									desc = L["Text to announce when Improved Drain Soul fades."],
									get = function() return db.procs.impSoulFire.fadedOutput end,
									set = function(_, value) db.procs.impSoulFire.fadedOutput = value end,
								},
							}
						},
						iconSettings = {
							type = "group",
							order = 2,
							name = L["Icon Settings"],
							args = {
								icon = {
									type = "toggle",
									order = 3,
									name = L["Show Icon"],
									desc = L["Show icon next to the proc message."],
									get = function() return db.procs.impSoulFire.icon end,
									set = function(_, value) db.procs.impSoulFire.icon = value end,
								},
								iconid = {
									type = "input",
									order = 4,
									name = L["Icon ID"],
									desc = L["Icon of a spell to display."],
									width = "half",
									disabled = function() return not db.procs.impSoulFire.icon end,
									get = function() return db.procs.impSoulFire.iconid end,
									set = function(_, value) db.procs.impSoulFire.iconid = value end,
								},
								iconView = {
									type = "description",
									name = "",
									order = 5,
									width = "half",
									disabled = function() return not db.procs.impSoulFire.icon end,
									image = function() return GetSpellTexture(db.procs.impSoulFire.iconid) end,
									imageWidth = 50,
									imageHeight = 50,
								},
							},
						},
						soundSettings = {
							type = "group",
							order = 3,
							name = L["Sound Settings"],
							args = {
								playSound = {
									type = "toggle",
									order = 1,
									name = L["Play Tick Sound"],
									desc = L["Play a sound when Improved Soul Fire procs."],
									get = function() return db.procs.impSoulFire.playSound end,
									set = function(_, value) db.procs.impSoulFire.playSound = value end,
								},
								sound = {
									type = "select", dialogControl = 'LSM30_Sound',
									order = 2,
									name = L["Tick Sound"],
									desc = L["Sound to play when Improved Soul Fire procs."],
									values = AceGUIWidgetLSMlists.sound,
									get = function() return db.procs.impSoulFire.sound end,
									set = function(_, value) db.procs.impSoulFire.sound = value end,
									disabled = function() return not db.procs.impSoulFire.playSound end,
								},
							},
						},
						fontSettings = {
							type = "group",
							name = L["Font Settings"],
							order = 4,
							disabled = function() return db.general.globalFont end,
							args = {
								fontFace = {
									type = "select", dialogControl = "LSM30_Font",
									order = 1,
									name = L["Font"],
									desc = L["The font to use for the proc notification."],
									values = AceGUIWidgetLSMlists.font,
									get = function() return db.procs.impSoulFire.fontFace end,
									set = function(_, value) db.procs.impSoulFire.fontFace = value end,
								},
								fontOutline = {
									type = "select",
									order = 2,
									name = L["Font Outline"],
									desc = L["Outline of the font."],
									get = function() return db.procs.impSoulFire.fontOutline end,
									set = function(_, value) db.procs.impSoulFire.fontOutline = value end,
									values = {
										["NORMAL"] 			= L["Normal"],
										["OUTLINE"]			= L["Outline"],
										["THICKOUTLINE"]	= L["Thick"],
									}
								},
								fontSize = {
									type = "range",
									order = 3,
									name = L["Font Size"],
									desc = L["Font Size of proc notification."],
									min = 9, max = 48, step = 1,
									get = function() return db.procs.impSoulFire.fontSize end,
									set = function(_, value) db.procs.impSoulFire.fontSize = value end,
								},
								fontColor = {
									type = "color",
									order = 4,
									name = L["Font Color"],
									desc = L["Color of the proc notification text."],
									get = function(info)
										local t = db.procs.impSoulFire.fontColor
										return t.r, t.g, t.b
									end,
									set = function(info, r, g, b)
										db.procs.impSoulFire.fontColor = {
											r = r,
											g = g,
											b = b,
										}
									end,
								},
							},
						},
					},
				},
				moltenCore = {
					type = "group",
					order = 6,
					name = L["Molten Core"],
					desc = L["Announce when Molten Core procs."],
					args = {
						generalSettings = {
							type = "group",
							order = 1,
							name = L["General Settings"],
							args = {
								enabled = {
									type = "toggle",
									order = 1,
									name = L["Enabled"],
									desc = L["Enable or disable the Molten Core proc notifications."],
									width = "double",
									get = function() return db.procs.moltenCore.enabled end,
									set = function(_, value) db.procs.moltenCore.enabled = value end,
								},
								enableText = {
									type = "toggle",
									order = 2,
									name = L["Enable Proc Text"],
									desc = L["Enable or disable the text message when Molten Core procs."],
									get = function() return db.procs.moltenCore.enableText end,
									set = function(_, value) db.procs.moltenCore.enableText = value end,
								},
								output = {
									type = "input",
									order = 3,
									name = L["Output Text"],
									desc = L["Text to announce when Molten Core procs."],
									width = "double",
									disabled = function() return not db.procs.moltenCore.enableText end,
									get = function() return db.procs.moltenCore.output end,
									set = function(_, value) db.procs.moltenCore.output = value end,
								},
							}
						},
						iconSettings = {
							type = "group",
							order = 2,
							name = L["Icon Settings"],
							args = {
								icon = {
									type = "toggle",
									order = 3,
									name = L["Show Icon"],
									desc = L["Show icon next to the proc message."],
									get = function() return db.procs.moltenCore.icon end,
									set = function(_, value) db.procs.moltenCore.icon = value end,
								},
								iconid = {
									type = "input",
									order = 4,
									name = L["Icon ID"],
									desc = L["Icon of a spell to display."],
									width = "half",
									disabled = function() return not db.procs.moltenCore.icon end,
									get = function() return db.procs.moltenCore.iconid end,
									set = function(_, value) db.procs.moltenCore.iconid = value end,
								},
								iconView = {
									type = "description",
									name = "",
									order = 5,
									width = "half",
									disabled = function() return not db.procs.moltenCore.icon end,
									image = function() return GetSpellTexture(db.procs.moltenCore.iconid) end,
									imageWidth = 50,
									imageHeight = 50,
								},
							},
						},
						soundSettings = {
							type = "group",
							order = 3,
							name = L["Sound Settings"],
							args = {
								playSound = {
									type = "toggle",
									order = 1,
									name = L["Play Tick Sound"],
									desc = L["Play a sound when Molten Core procs."],
									get = function() return db.procs.moltenCore.playSound end,
									set = function(_, value) db.procs.moltenCore.playSound = value end,
								},
								sound = {
									type = "select", dialogControl = 'LSM30_Sound',
									order = 2,
									name = L["Tick Sound"],
									desc = L["Sound to play when Molten Core procs."],
									values = AceGUIWidgetLSMlists.sound,
									get = function() return db.procs.moltenCore.sound end,
									set = function(_, value) db.procs.moltenCore.sound = value end,
									disabled = function() return not db.procs.moltenCore.playSound end,
								},
							},
						},
						fontSettings = {
							type = "group",
							name = L["Font Settings"],
							order = 4,
							disabled = function() return db.general.globalFont end,
							args = {
								fontFace = {
									type = "select", dialogControl = "LSM30_Font",
									order = 1,
									name = L["Font"],
									desc = L["The font to use for the proc notification."],
									values = AceGUIWidgetLSMlists.font,
									get = function() return db.procs.moltenCore.fontFace end,
									set = function(_, value) db.procs.moltenCore.fontFace = value end,
								},
								fontOutline = {
									type = "select",
									order = 2,
									name = L["Font Outline"],
									desc = L["Outline of the font."],
									get = function() return db.procs.moltenCore.fontOutline end,
									set = function(_, value) db.procs.moltenCore.fontOutline = value end,
									values = {
										["NORMAL"] 			= L["Normal"],
										["OUTLINE"]			= L["Outline"],
										["THICKOUTLINE"]	= L["Thick"],
									}
								},
								fontSize = {
									type = "range",
									order = 3,
									name = L["Font Size"],
									desc = L["Font Size of proc notification."],
									min = 9, max = 48, step = 1,
									get = function() return db.procs.moltenCore.fontSize end,
									set = function(_, value) db.procs.moltenCore.fontSize = value end,
								},
								fontColor = {
									type = "color",
									order = 4,
									name = L["Font Color"],
									desc = L["Color of the proc notification text."],
									get = function(info)
										local t = db.procs.moltenCore.fontColor
										return t.r, t.g, t.b
									end,
									set = function(info, r, g, b)
										db.procs.moltenCore.fontColor = {
											r = r,
											g = g,
											b = b,
										}
									end,
								},
							},
						},
					},
				},
				nightfall = {
					type = "group",
					order = 7,
					name = L["Nightfall"],
					desc = L["Announce when Nightfall procs."],
					args = {
						generalSettings = {
							type = "group",
							order = 1,
							name = L["General Settings"],
							args = {
								enabled = {
									type = "toggle",
									order = 1,
									name = L["Enabled"],
									desc = L["Enable or disable the Nightfall proc notifications."],
									width = "double",
									get = function() return db.procs.nightfall.enabled end,
									set = function(_, value) db.procs.nightfall.enabled = value end,
								},
								enableText = {
									type = "toggle",
									order = 2,
									name = L["Enable Proc Text"],
									desc = L["Enable or disable the text message when Nightfall procs."],
									get = function() return db.procs.nightfall.enableText end,
									set = function(_, value) db.procs.nightfall.enableText = value end,
								},
								output = {
									type = "input",
									order = 3,
									name = L["Output Text"],
									desc = L["Text to announce when Nightfall procs."],
									width = "double",
									disabled = function() return not db.procs.nightfall.enableText end,
									get = function() return db.procs.nightfall.output end,
									set = function(_, value) db.procs.nightfall.output = value end,
								},
							}
						},
						iconSettings = {
							type = "group",
							order = 2,
							name = L["Icon Settings"],
							args = {
								icon = {
									type = "toggle",
									order = 3,
									name = L["Show Icon"],
									desc = L["Show icon next to the proc message."],
									get = function() return db.procs.nightfall.icon end,
									set = function(_, value) db.procs.nightfall.icon = value end,
								},
								iconid = {
									type = "input",
									order = 4,
									name = L["Icon ID"],
									desc = L["Icon of a spell to display."],
									width = "half",
									disabled = function() return not db.procs.nightfall.icon end,
									get = function() return db.procs.nightfall.iconid end,
									set = function(_, value) db.procs.nightfall.iconid = value end,
								},
								iconView = {
									type = "description",
									name = "",
									order = 5,
									width = "half",
									disabled = function() return not db.procs.nightfall.icon end,
									image = function() return GetSpellTexture(db.procs.nightfall.iconid) end,
									imageWidth = 50,
									imageHeight = 50,
								},
							},
						},
						soundSettings = {
							type = "group",
							order = 3,
							name = L["Sound Settings"],
							args = {
								playSound = {
									type = "toggle",
									order = 1,
									name = L["Play Tick Sound"],
									desc = L["Play a sound when Nightfall procs."],
									get = function() return db.procs.nightfall.playSound end,
									set = function(_, value) db.procs.nightfall.playSound = value end,
								},
								sound = {
									type = "select", dialogControl = 'LSM30_Sound',
									order = 2,
									name = L["Tick Sound"],
									desc = L["Sound to play when Nightfall procs."],
									values = AceGUIWidgetLSMlists.sound,
									get = function() return db.procs.nightfall.sound end,
									set = function(_, value) db.procs.nightfall.sound = value end,
									disabled = function() return not db.procs.nightfall.playSound end,
								},
							},
						},
						fontSettings = {
							type = "group",
							name = L["Font Settings"],
							order = 4,
							disabled = function() return db.general.globalFont end,
							args = {
								fontFace = {
									type = "select", dialogControl = "LSM30_Font",
									order = 1,
									name = L["Font"],
									desc = L["The font to use for the proc notification."],
									values = AceGUIWidgetLSMlists.font,
									get = function() return db.procs.nightfall.fontFace end,
									set = function(_, value) db.procs.nightfall.fontFace = value end,
								},
								fontOutline = {
									type = "select",
									order = 2,
									name = L["Font Outline"],
									desc = L["Outline of the font."],
									get = function() return db.procs.nightfall.fontOutline end,
									set = function(_, value) db.procs.nightfall.fontOutline = value end,
									values = {
										["NORMAL"] 			= L["Normal"],
										["OUTLINE"]			= L["Outline"],
										["THICKOUTLINE"]	= L["Thick"],
									}
								},
								fontSize = {
									type = "range",
									order = 3,
									name = L["Font Size"],
									desc = L["Font Size of proc notification."],
									min = 9, max = 48, step = 1,
									get = function() return db.procs.nightfall.fontSize end,
									set = function(_, value) db.procs.nightfall.fontSize = value end,
								},
								fontColor = {
									type = "color",
									order = 4,
									name = L["Font Color"],
									desc = L["Color of the proc notification text."],
									get = function(info)
										local t = db.procs.nightfall.fontColor
										return t.r, t.g, t.b
									end,
									set = function(info, r, g, b)
										db.procs.nightfall.fontColor = {
											r = r,
											g = g,
											b = b,
										}
									end,
								},
							},
						},
					},
				},
			},
		},
		misc = {
			type = "group",
			name = L["Miscellaneous"],
			desc = L["Various other settings that didn't have a home elsewhere."],
			order = 6,
			childGroups = "tab",
			args = {
				lifeTap = {
					type = "group",
					order = 1,
					name = L["Life Tap"],
					desc = L["Announce when you should Life Tap based on your mana threshold."],
					args = {
						generalSettings = {
							type = "group",
							order = 1,
							name = L["General Settings"],
							args = {
								enabled = {
									type = "toggle",
									order = 1,
									name = L["Enabled"],
									desc = L["Enable or disable the Life Tap notifications."],
									width = "double",
									get = function() return db.misc.lifeTap.enabled end,
									set = function(_, value) db.misc.lifeTap.enabled = value end,
								},
								threshold = {
									type = "range",
									order = 2,
									name = L["Warning Threshold"],
									desc = L["The percentage of your mana that you should be warned to use Life Tap."],
									min = 0, max = 100, step = 5,
									get = function() return db.misc.lifeTap.threshold end,
									set = function(_, value) db.misc.lifeTap.threshold = value end,
								},
								enableText = {
									type = "toggle",
									order = 3,
									name = L["Enable Warning Text"],
									desc = L["Enable or disable the text message when your mana falls below the threshold."],
									get = function() return db.misc.lifeTap.enableText end,
									set = function(_, value) db.misc.lifeTap.enableText = value end,
								},
								output = {
									type = "input",
									order = 4,
									name = L["Output Text"],
									desc = L["Text to announce when you should Life Tap."],
									width = "double",
									disabled = function() return not db.misc.lifeTap.enableText end,
									get = function() return db.misc.lifeTap.output end,
									set = function(_, value) db.misc.lifeTap.output = value end,
								},
								showValue = {
									type = "toggle",
									order = 5,
									name = L["Show Mana Value"],
									desc = L["Show the mana value in the warning text."],
									width = "double",
									get = function() return db.misc.lifeTap.showValue end,
									set = function(_, value) db.misc.lifeTap.showValue = value end,
								},
								manaValue = {
									type = "select",
									order = 6,
									name = L["Mana to Display"],
									desc = L["How to display the mana, real value or the percentage."],
									width = "double",
									values = {
										["ACTUAL"]	= L["Actual Mana"],
										["PERCENT"]	= L["Mana Percent"],	
									},
									get = function() return db.misc.lifeTap.manaValue end,
									set = function(_, value) db.misc.lifeTap.manaValue = value end,
								},
							}
						},
						iconSettings = {
							type = "group",
							order = 2,
							name = L["Icon Settings"],
							args = {
								icon = {
									type = "toggle",
									order = 3,
									name = L["Show Icon"],
									desc = L["Show icon next to the proc message."],
									get = function() return db.misc.lifeTap.icon end,
									set = function(_, value) db.misc.lifeTap.icon = value end,
								},
								iconid = {
									type = "input",
									order = 4,
									name = L["Icon ID"],
									desc = L["Icon of a spell to display."],
									width = "half",
									disabled = function() return not db.misc.lifeTap.icon end,
									get = function() return db.misc.lifeTap.iconid end,
									set = function(_, value) db.misc.lifeTap.iconid = value end,
								},
								iconView = {
									type = "description",
									name = "",
									order = 5,
									width = "half",
									disabled = function() return not db.misc.lifeTap.icon end,
									image = function() return GetSpellTexture(db.misc.lifeTap.iconid) end,
									imageWidth = 50,
									imageHeight = 50,
								},
							},
						},
						soundSettings = {
							type = "group",
							order = 3,
							name = L["Sound Settings"],
							args = {
								playSound = {
									type = "toggle",
									order = 1,
									name = L["Play Tick Sound"],
									desc = L["Play a sound when Nightfall procs."],
									get = function() return db.misc.lifeTap.playSound end,
									set = function(_, value) db.misc.lifeTap.playSound = value end,
								},
								sound = {
									type = "select", dialogControl = 'LSM30_Sound',
									order = 2,
									name = L["Tick Sound"],
									desc = L["Sound to play when you should Life Tap."],
									values = AceGUIWidgetLSMlists.sound,
									get = function() return db.misc.lifeTap.sound end,
									set = function(_, value) db.misc.lifeTap.sound = value end,
									disabled = function() return not db.misc.lifeTap.playSound end,
								},
							},
						},
						fontSettings = {
							type = "group",
							name = L["Font Settings"],
							order = 4,
							disabled = function() return db.general.globalFont end,
							args = {
								fontFace = {
									type = "select", dialogControl = "LSM30_Font",
									order = 1,
									name = L["Font"],
									desc = L["The font to use for the notification."],
									values = AceGUIWidgetLSMlists.font,
									get = function() return db.misc.lifeTap.fontFace end,
									set = function(_, value) db.misc.lifeTap.fontFace = value end,
								},
								fontOutline = {
									type = "select",
									order = 2,
									name = L["Font Outline"],
									desc = L["Outline of the font."],
									get = function() return db.misc.lifeTap.fontOutline end,
									set = function(_, value) db.misc.lifeTap.fontOutline = value end,
									values = {
										["NORMAL"] 			= L["Normal"],
										["OUTLINE"]			= L["Outline"],
										["THICKOUTLINE"]	= L["Thick"],
									}
								},
								fontSize = {
									type = "range",
									order = 3,
									name = L["Font Size"],
									desc = L["Font Size of the notification."],
									min = 9, max = 48, step = 1,
									get = function() return db.misc.lifeTap.fontSize end,
									set = function(_, value) db.misc.lifeTap.fontSize = value end,
								},
								fontColor = {
									type = "color",
									order = 4,
									name = L["Font Color"],
									desc = L["Color of the notification text."],
									get = function(info)
										local t = db.misc.lifeTap.fontColor
										return t.r, t.g, t.b
									end,
									set = function(info, r, g, b)
										db.misc.lifeTap.fontColor = {
											r = r,
											g = g,
											b = b,
										}
									end,
								},
							},
						},	
					},
				},
				curses = {
					type = "group",
					order = 2,
					name = L["Curse Tracker"],
					desc = L["Keeps track of the Curses on a target so you know which one to cast."],
					args = {
						enabled = {
							type = "toggle",
							order = 1,
							name = L["Enabled"],
							desc = L["Enable or disable the Curse tracker."],
							get = function() return db.misc.curses.enabled end,
							set = function(_, value)
								db.misc.curses.enabled = value
								if value then
									CurseTracker:Show()
								else
									CurseTracker:Hide()
								end
							end,
						},
						locked = {
							type = "toggle",
							order = 2,
							name = L["Frame Locked"],
							desc = L["Lock or unlock the Curse tracker frame."],
							disabled = function() return not db.misc.curses.enabled end,
							get = function() return db.misc.curses.locked end,
							set = function(_, value)
								db.misc.curses.locked = value
								if value then
									CurseTrackerBG:Hide()
									CurseTracker:SetScript("OnMouseDown", nil)
								else
									CurseTrackerBG:Show()
									CurseTracker:SetScript("OnMouseDown", function() CurseTracker:StartMoving() end)
								end
							end,
						},
						alpha = {
							type = "range",
							order = 3,
							name = L["Frame Alpha"],
							desc = L["Normal frame transparency.\n\n|cff00ff00NOTE|r This is also the transparency of the curses when the curse is |cffff0000NOT|r on your current target."],
							min = 0.0, max = 1.0, step = 0.1,
							disabled = function() return not db.misc.curses.enabled end,
							get = function() return db.misc.curses.alpha end,
							set = function(_, value)
								db.misc.curses.alpha = value
								CurseTracker:SetCurseAlpha(value)
							end,
						},
						curseAlpha = {
							type = "range",
							order = 4,
							name = L["Curse Applied Alpha"],
							desc = L["Transparency of a curse that is applied to your current target."],
							min = 0.0, max = 1.0, step = 0.1,
							disabled = function() return not db.misc.curses.enabled end,
							get = function() return db.misc.curses.curseAlpha end,
							set = function(_, value) db.misc.curses.curseAlpha = value end,
						},
						scale = {
							type = "range",
							order = 5,
							name = L["Frame Scale"],
							desc = L["Scale the size of the frame."],
							min = 0.1, max = 2.0, step = 0.1,
							disabled = function() return not db.misc.curses.enabled end,
							get = function() return db.misc.curses.scale end,
							set = function(_, value)
								db.misc.curses.scale = value
								CurseTracker:SetScale(value)
							end,
						},
						curseSettings = {
							type = "group",
							order = 6,
							name = L["Curse Settings"],
							guiInline = true,
							disabled = function() return not db.misc.curses.enabled end,
							args = {
								elements = {
									type = "toggle",
									order = 1,
									name = L["Curse of the Elements"],
									desc = L["Track Curse of the Elements."],
									get = function() return db.misc.curses.elements end,
									set = function(_, value)
										db.misc.curses.elements = value
										CurseTracker:UpdateCurses()
									end,
								},
								exhaustion = {
									type = "toggle",
									order = 2,
									name = L["Curse of Exhaustion"],
									desc = L["Track Curse of Exhaustion."],
									get = function() return db.misc.curses.exhaustion end,
									set = function(_, value)
										db.misc.curses.exhaustion = value
										CurseTracker:UpdateCurses()
									end,
								},
								tongues = {
									type = "toggle",
									order = 3,
									name = L["Curse of Tongues"],
									desc = L["Track Curse of Tongues."],
									get = function() return db.misc.curses.tongues end,
									set = function(_, value)
										db.misc.curses.tongues = value
										CurseTracker:UpdateCurses()
									end,
								},
								weakness = {
									type = "toggle",
									order = 4,
									name = L["Curse of Weakness"],
									desc = L["Track Curse of Weakness."],
									get = function() return db.misc.curses.weakness end,
									set = function(_, value)
										db.misc.curses.weakness = value
										CurseTracker:UpdateCurses()
									end,
								},
							},
						},
					},
				},
			},
		},
		display = {
			type = "group",
			name = L["Display Settings"],
			order = 7,
			args = {}
		},
	}
}

function SoulSucker:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("SoulSuckerDB", defaults)
	db = self.db.global
	self:SetSinkStorage(db.display.sinkOptions)

	-- build the curse tracker frame
	CurseTracker:Setup()
	
	-- register the options table w/ ace & add it to blizzard options frame
	options.args.display.args.output = SoulSucker:GetSinkAce3OptionsDataTable()
	options.args.display.args.output.guiInline = true
	options.args.display.args.output.name = L["Display Options"]
	LibStub("AceConfig-3.0"):RegisterOptionsTable("SoulSucker", options, {"ss", "soulsucker"})
	
	-- add to blizzard's addon interface
	self.frames = {}
	self.frames.general		= AceConfigDialog:AddToBlizOptions("SoulSucker", L["Soul Sucker"], nil, "general")
	self.frames.announce	= AceConfigDialog:AddToBlizOptions("SoulSucker", L["Announcements"], "Soul Sucker", "announce")
	self.frames.misc		= AceConfigDialog:AddToBlizOptions("SoulSucker", L["Miscellaneous"], "Soul Sucker", "misc")
	self.frames.procs		= AceConfigDialog:AddToBlizOptions("SoulSucker", L["Procs"], "Soul Sucker", "procs")
	self.frames.ticks		= AceConfigDialog:AddToBlizOptions("SoulSucker", L["Spell Ticks"], "Soul Sucker", "ticks")
	self.frames.warning		= AceConfigDialog:AddToBlizOptions("SoulSucker", L["Execute Warning"], "Soul Sucker", "warning")
	self.frames.display		= AceConfigDialog:AddToBlizOptions("SoulSucker", L["Display"], "Soul Sucker", "display")
	self.frames.about		= LibStub("LibAboutPanel").new("Soul Sucker", "SoulSucker")
	
		-- register our config chat command
	SoulSucker:RegisterChatCommand("ssconfig", function()
		ssPrint("Showing Configuration Options")
		InterfaceOptionsFrame_OpenToCategory(self.frames.general)
	end)
	
	-- register our sounds with LibSharedMedia
	if not LSM:IsValid("sound", "Soul Sucker Tick") then
		LSM:Register("sound", "Soul Sucker Tick", [[Interface\AddOns\SoulSucker\Sounds\tick.mp3]])
	end
	if not LSM:IsValid("sound", "Soul Sucker Execute") then
		LSM:Register("sound", "Soul Sucker Execute", [[Interface\AddOns\SoulSucker\Sounds\execute.mp3]])
	end
	if not LSM:IsValid("sound", "SS Finish Him") then
		LSM:Register("sound", "SS Finish Him", [[Interface\AddOns\SoulSucker\Sounds\finishhim.mp3]])
	end
	if not LSM:IsValid("sound", "SS Drain Life Tick") then
		LSM:Register("sound", "SS Drain Life Tick", [[Interface\AddOns\SoulSucker\Sounds\lifetick.mp3]])
	end
	if not LSM:IsValid("sound", "SS Life Tap") then
		LSM:Register("sound", "SS Life Tap", [[Interface\AddOns\SoulSucker\Sounds\alarm.mp3]])
	end
	
	-- auto disable settings
	if db.warning.autoDisable then
		db.warning.drainSoul.enabled	= isAffliction()
		db.warning.decimation.enabled	= hasDecimation()
		db.warning.shadowBurn.enabled	= hasShadowburn() 
	end
	
	if db.procs.autoDisable then
		db.procs.eradication.enabled	= hasEradication()
		db.procs.moltenCore.enabled		= hasMoltenCore()
		db.procs.nightfall.enabled		= hasNightfall()
	end
end